#include <stdio.h>

#include "PrintTypes.h"

#ifdef __linux__
#include <pthread.h>

static pthread_mutex_t g_printing_mutex = PTHREAD_MUTEX_INITIALIZER;

#endif

void PrintEvent_Action_Service_Report(const char *paramName, const asn1SccEvent_Action_Service_Report *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    if ((*pData).kind == foo_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::foo %lld\n", paramName, (*pData).u.foo);
        #else
        printf("%s::foo %d\n", paramName, (*pData).u.foo);
        #endif
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Octet_String_11(const char *paramName, const asn1SccFixed_Octet_String_11 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<11; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintStandard_Boolean(const char *paramName, const asn1SccStandard_Boolean *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    printf("%s %d\n", paramName, (int)(*pData));
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Character_String_15(const char *paramName, const asn1SccFixed_Character_String_15 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<15; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Character_String_14(const char *paramName, const asn1SccFixed_Character_String_14 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<14; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Character_String_10(const char *paramName, const asn1SccFixed_Character_String_10 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<10; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintSigned_Integer(const char *paramName, const asn1SccSigned_Integer *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    #if WORD_SIZE==8
    printf("%s %lld\n", paramName, (*pData));
    #else
    printf("%s %d\n", paramName, (*pData));
    #endif
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintLow_Severity_Error_Anomaly_Report(const char *paramName, const asn1SccLow_Severity_Error_Anomaly_Report *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    #if WORD_SIZE==8
    printf("%s::rid %lld\n", paramName, (*pData).rid);
    #else
    printf("%s::rid %d\n", paramName, (*pData).rid);
    #endif
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintTelecommand_Verification_Service_Report(const char *paramName, const asn1SccTelecommand_Verification_Service_Report *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    if ((*pData).kind == success_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::success::packet_id %lld\n", paramName, (*pData).u.success.packet_id);
        #else
        printf("%s::success::packet_id %d\n", paramName, (*pData).u.success.packet_id);
        #endif
    }
    else if ((*pData).kind == failure_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::failure::packet_id %lld\n", paramName, (*pData).u.failure.packet_id);
        #else
        printf("%s::failure::packet_id %d\n", paramName, (*pData).u.failure.packet_id);
        #endif
        #if WORD_SIZE==8
        printf("%s::failure::code %lld\n", paramName, (*pData).u.failure.code);
        #else
        printf("%s::failure::code %d\n", paramName, (*pData).u.failure.code);
        #endif
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Character_String_16(const char *paramName, const asn1SccFixed_Character_String_16 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<16; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintReport_ID(const char *paramName, const asn1SccReport_ID *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    #if WORD_SIZE==8
    printf("%s %lld\n", paramName, (*pData));
    #else
    printf("%s %d\n", paramName, (*pData));
    #endif
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintOn_Board_Time(const char *paramName, const asn1SccOn_Board_Time *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    #if WORD_SIZE==8
    printf("%s::p_field::coarse_time_rep %lld\n", paramName, (*pData).p_field.coarse_time_rep);
    #else
    printf("%s::p_field::coarse_time_rep %d\n", paramName, (*pData).p_field.coarse_time_rep);
    #endif
    #if WORD_SIZE==8
    printf("%s::p_field::fine_time_rep %lld\n", paramName, (*pData).p_field.fine_time_rep);
    #else
    printf("%s::p_field::fine_time_rep %d\n", paramName, (*pData).p_field.fine_time_rep);
    #endif
    {
        int i;
        printf("%s::coarse_time ", paramName);
        for(i=0; i<4; i++)
            printf("%c", (*pData).coarse_time.arr[i]);
        printf("\n");
    }

    {
        int i;
        printf("%s::fine_time ", paramName);
        for(i=0; i<3; i++)
            printf("%c", (*pData).fine_time.arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Bit_String_2(const char *paramName, const asn1SccFixed_Bit_String_2 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i1;
        for(i1=0; i1<2; i1++) {
            printf("%s::Elem %d\n", paramName, (int)(*pData).arr[i1]);
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintEvent_Reporting_Service_Report(const char *paramName, const asn1SccEvent_Reporting_Service_Report *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    if ((*pData).kind == normal_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::normal::rid %lld\n", paramName, (*pData).u.normal.rid);
        #else
        printf("%s::normal::rid %d\n", paramName, (*pData).u.normal.rid);
        #endif
    }
    else if ((*pData).kind == anomaly_PRESENT) {
        if ((*pData).u.anomaly.kind == low_PRESENT) {
            #if WORD_SIZE==8
            printf("%s::anomaly::low::rid %lld\n", paramName, (*pData).u.anomaly.u.low.rid);
            #else
            printf("%s::anomaly::low::rid %d\n", paramName, (*pData).u.anomaly.u.low.rid);
            #endif
        }
        else if ((*pData).u.anomaly.kind == medium_PRESENT) {
            #if WORD_SIZE==8
            printf("%s::anomaly::medium::rid %lld\n", paramName, (*pData).u.anomaly.u.medium.rid);
            #else
            printf("%s::anomaly::medium::rid %d\n", paramName, (*pData).u.anomaly.u.medium.rid);
            #endif
        }
        else if ((*pData).u.anomaly.kind == high_PRESENT) {
            #if WORD_SIZE==8
            printf("%s::anomaly::high::rid %lld\n", paramName, (*pData).u.anomaly.u.high.rid);
            #else
            printf("%s::anomaly::high::rid %d\n", paramName, (*pData).u.anomaly.u.high.rid);
            #endif
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Octet_String_10(const char *paramName, const asn1SccFixed_Octet_String_10 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<10; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Octet_String_13(const char *paramName, const asn1SccFixed_Octet_String_13 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<13; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Octet_String_12(const char *paramName, const asn1SccFixed_Octet_String_12 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<12; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Octet_String_15(const char *paramName, const asn1SccFixed_Octet_String_15 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<15; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Octet_String_14(const char *paramName, const asn1SccFixed_Octet_String_14 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<14; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintTelecommand_Packet_ID(const char *paramName, const asn1SccTelecommand_Packet_ID *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    #if WORD_SIZE==8
    printf("%s %lld\n", paramName, (*pData));
    #else
    printf("%s %d\n", paramName, (*pData));
    #endif
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Character_String_11(const char *paramName, const asn1SccFixed_Character_String_11 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<11; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Octet_String_9(const char *paramName, const asn1SccFixed_Octet_String_9 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<9; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Octet_String_8(const char *paramName, const asn1SccFixed_Octet_String_8 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<8; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintParameter_Value(const char *paramName, const asn1SccParameter_Value *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    if ((*pData).kind == type_1_0_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::type_1_0 %lld\n", paramName, (*pData).u.type_1_0);
        #else
        printf("%s::type_1_0 %d\n", paramName, (*pData).u.type_1_0);
        #endif
    }
    else if ((*pData).kind == type_1_1_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::type_1_1 %lld\n", paramName, (*pData).u.type_1_1);
        #else
        printf("%s::type_1_1 %d\n", paramName, (*pData).u.type_1_1);
        #endif
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Character_String_4(const char *paramName, const asn1SccFixed_Character_String_4 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<4; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Octet_String_1(const char *paramName, const asn1SccFixed_Octet_String_1 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<1; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Octet_String_3(const char *paramName, const asn1SccFixed_Octet_String_3 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<3; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintCheck_State(const char *paramName, const asn1SccCheck_State *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    printf("%s::id %d\n", paramName, (int)(*pData).id);
    if ((*pData).value.kind == type_1_0_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::value::type_1_0 %lld\n", paramName, (*pData).value.u.type_1_0);
        #else
        printf("%s::value::type_1_0 %d\n", paramName, (*pData).value.u.type_1_0);
        #endif
    }
    else if ((*pData).value.kind == type_1_1_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::value::type_1_1 %lld\n", paramName, (*pData).value.u.type_1_1);
        #else
        printf("%s::value::type_1_1 %d\n", paramName, (*pData).value.u.type_1_1);
        #endif
    }
    if ((*pData).limit_crossed.kind == type_1_0_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::limit_crossed::type_1_0 %lld\n", paramName, (*pData).limit_crossed.u.type_1_0);
        #else
        printf("%s::limit_crossed::type_1_0 %d\n", paramName, (*pData).limit_crossed.u.type_1_0);
        #endif
    }
    else if ((*pData).limit_crossed.kind == type_1_1_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::limit_crossed::type_1_1 %lld\n", paramName, (*pData).limit_crossed.u.type_1_1);
        #else
        printf("%s::limit_crossed::type_1_1 %d\n", paramName, (*pData).limit_crossed.u.type_1_1);
        #endif
    }
    printf("%s::previous_checking_status %d\n", paramName, (int)(*pData).previous_checking_status);
    printf("%s::current_checking_status %d\n", paramName, (int)(*pData).current_checking_status);
    #if WORD_SIZE==8
    printf("%s::transition_time::p_field::coarse_time_rep %lld\n", paramName, (*pData).transition_time.p_field.coarse_time_rep);
    #else
    printf("%s::transition_time::p_field::coarse_time_rep %d\n", paramName, (*pData).transition_time.p_field.coarse_time_rep);
    #endif
    #if WORD_SIZE==8
    printf("%s::transition_time::p_field::fine_time_rep %lld\n", paramName, (*pData).transition_time.p_field.fine_time_rep);
    #else
    printf("%s::transition_time::p_field::fine_time_rep %d\n", paramName, (*pData).transition_time.p_field.fine_time_rep);
    #endif
    {
        int i;
        printf("%s::transition_time::coarse_time ", paramName);
        for(i=0; i<4; i++)
            printf("%c", (*pData).transition_time.coarse_time.arr[i]);
        printf("\n");
    }

    {
        int i;
        printf("%s::transition_time::fine_time ", paramName);
        for(i=0; i<3; i++)
            printf("%c", (*pData).transition_time.fine_time.arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Octet_String_5(const char *paramName, const asn1SccFixed_Octet_String_5 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<5; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Octet_String_4(const char *paramName, const asn1SccFixed_Octet_String_4 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<4; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Octet_String_7(const char *paramName, const asn1SccFixed_Octet_String_7 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<7; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Octet_String_6(const char *paramName, const asn1SccFixed_Octet_String_6 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<6; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Character_String_6(const char *paramName, const asn1SccFixed_Character_String_6 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<6; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Bit_String_9(const char *paramName, const asn1SccFixed_Bit_String_9 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i2;
        for(i2=0; i2<9; i2++) {
            printf("%s::Elem %d\n", paramName, (int)(*pData).arr[i2]);
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Bit_String_8(const char *paramName, const asn1SccFixed_Bit_String_8 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i3;
        for(i3=0; i3<8; i3++) {
            printf("%s::Elem %d\n", paramName, (int)(*pData).arr[i3]);
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Bit_String_7(const char *paramName, const asn1SccFixed_Bit_String_7 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i4;
        for(i4=0; i4<7; i4++) {
            printf("%s::Elem %d\n", paramName, (int)(*pData).arr[i4]);
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Bit_String_6(const char *paramName, const asn1SccFixed_Bit_String_6 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i5;
        for(i5=0; i5<6; i5++) {
            printf("%s::Elem %d\n", paramName, (int)(*pData).arr[i5]);
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Bit_String_5(const char *paramName, const asn1SccFixed_Bit_String_5 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i6;
        for(i6=0; i6<5; i6++) {
            printf("%s::Elem %d\n", paramName, (int)(*pData).arr[i6]);
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Bit_String_4(const char *paramName, const asn1SccFixed_Bit_String_4 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i7;
        for(i7=0; i7<4; i7++) {
            printf("%s::Elem %d\n", paramName, (int)(*pData).arr[i7]);
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Bit_String_3(const char *paramName, const asn1SccFixed_Bit_String_3 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i8;
        for(i8=0; i8<3; i8++) {
            printf("%s::Elem %d\n", paramName, (int)(*pData).arr[i8]);
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintMedium_Severity_Error_Anomaly_Report(const char *paramName, const asn1SccMedium_Severity_Error_Anomaly_Report *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    #if WORD_SIZE==8
    printf("%s::rid %lld\n", paramName, (*pData).rid);
    #else
    printf("%s::rid %d\n", paramName, (*pData).rid);
    #endif
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Character_String_13(const char *paramName, const asn1SccFixed_Character_String_13 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<13; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Character_String_12(const char *paramName, const asn1SccFixed_Character_String_12 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<12; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Character_String_5(const char *paramName, const asn1SccFixed_Character_String_5 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<5; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintTransition_Report(const char *paramName, const asn1SccTransition_Report *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    printf("%s::id %d\n", paramName, (int)(*pData).id);
    if ((*pData).value.kind == type_1_0_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::value::type_1_0 %lld\n", paramName, (*pData).value.u.type_1_0);
        #else
        printf("%s::value::type_1_0 %d\n", paramName, (*pData).value.u.type_1_0);
        #endif
    }
    else if ((*pData).value.kind == type_1_1_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::value::type_1_1 %lld\n", paramName, (*pData).value.u.type_1_1);
        #else
        printf("%s::value::type_1_1 %d\n", paramName, (*pData).value.u.type_1_1);
        #endif
    }
    if ((*pData).limit_crossed.kind == type_1_0_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::limit_crossed::type_1_0 %lld\n", paramName, (*pData).limit_crossed.u.type_1_0);
        #else
        printf("%s::limit_crossed::type_1_0 %d\n", paramName, (*pData).limit_crossed.u.type_1_0);
        #endif
    }
    else if ((*pData).limit_crossed.kind == type_1_1_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::limit_crossed::type_1_1 %lld\n", paramName, (*pData).limit_crossed.u.type_1_1);
        #else
        printf("%s::limit_crossed::type_1_1 %d\n", paramName, (*pData).limit_crossed.u.type_1_1);
        #endif
    }
    printf("%s::previous_checking_status %d\n", paramName, (int)(*pData).previous_checking_status);
    printf("%s::current_checking_status %d\n", paramName, (int)(*pData).current_checking_status);
    #if WORD_SIZE==8
    printf("%s::transition_time::p_field::coarse_time_rep %lld\n", paramName, (*pData).transition_time.p_field.coarse_time_rep);
    #else
    printf("%s::transition_time::p_field::coarse_time_rep %d\n", paramName, (*pData).transition_time.p_field.coarse_time_rep);
    #endif
    #if WORD_SIZE==8
    printf("%s::transition_time::p_field::fine_time_rep %lld\n", paramName, (*pData).transition_time.p_field.fine_time_rep);
    #else
    printf("%s::transition_time::p_field::fine_time_rep %d\n", paramName, (*pData).transition_time.p_field.fine_time_rep);
    #endif
    {
        int i;
        printf("%s::transition_time::coarse_time ", paramName);
        for(i=0; i<4; i++)
            printf("%c", (*pData).transition_time.coarse_time.arr[i]);
        printf("\n");
    }

    {
        int i;
        printf("%s::transition_time::fine_time ", paramName);
        for(i=0; i<3; i++)
            printf("%c", (*pData).transition_time.fine_time.arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Character_String_7(const char *paramName, const asn1SccFixed_Character_String_7 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<7; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintVar_Bit_String(const char *paramName, const asn1SccVar_Bit_String *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i9;
        for(i9=0; i9<(*pData).nCount; i9++) {
            printf("%s::Elem %d\n", paramName, (int)(*pData).arr[i9]);
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Character_String_1(const char *paramName, const asn1SccFixed_Character_String_1 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<1; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintHigh_Severity_Error_Anomaly_Report(const char *paramName, const asn1SccHigh_Severity_Error_Anomaly_Report *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    #if WORD_SIZE==8
    printf("%s::rid %lld\n", paramName, (*pData).rid);
    #else
    printf("%s::rid %d\n", paramName, (*pData).rid);
    #endif
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintCheck_Definition(const char *paramName, const asn1SccCheck_Definition *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    if ((*pData).lower_bound.kind == type_1_0_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::lower_bound::type_1_0 %lld\n", paramName, (*pData).lower_bound.u.type_1_0);
        #else
        printf("%s::lower_bound::type_1_0 %d\n", paramName, (*pData).lower_bound.u.type_1_0);
        #endif
    }
    else if ((*pData).lower_bound.kind == type_1_1_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::lower_bound::type_1_1 %lld\n", paramName, (*pData).lower_bound.u.type_1_1);
        #else
        printf("%s::lower_bound::type_1_1 %d\n", paramName, (*pData).lower_bound.u.type_1_1);
        #endif
    }
    if ((*pData).upper_bound.kind == type_1_0_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::upper_bound::type_1_0 %lld\n", paramName, (*pData).upper_bound.u.type_1_0);
        #else
        printf("%s::upper_bound::type_1_0 %d\n", paramName, (*pData).upper_bound.u.type_1_0);
        #endif
    }
    else if ((*pData).upper_bound.kind == type_1_1_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::upper_bound::type_1_1 %lld\n", paramName, (*pData).upper_bound.u.type_1_1);
        #else
        printf("%s::upper_bound::type_1_1 %d\n", paramName, (*pData).upper_bound.u.type_1_1);
        #endif
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Character_String_2(const char *paramName, const asn1SccFixed_Character_String_2 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<2; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Character_String_9(const char *paramName, const asn1SccFixed_Character_String_9 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<9; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Character_String_8(const char *paramName, const asn1SccFixed_Character_String_8 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<8; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintOnboard_Monitoring_Service_Report(const char *paramName, const asn1SccOnboard_Monitoring_Service_Report *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    if ((*pData).kind == transition_PRESENT) {
        {
            int i10;
            for(i10=0; i10<(*pData).u.transition.nCount; i10++) {
                printf("%s::transition::Elem::id %d\n", paramName, (int)(*pData).u.transition.arr[i10].id);
                if ((*pData).u.transition.arr[i10].value.kind == type_1_0_PRESENT) {
                    #if WORD_SIZE==8
                    printf("%s::transition::Elem::value::type_1_0 %lld\n", paramName, (*pData).u.transition.arr[i10].value.u.type_1_0);
                    #else
                    printf("%s::transition::Elem::value::type_1_0 %d\n", paramName, (*pData).u.transition.arr[i10].value.u.type_1_0);
                    #endif
                }
                else if ((*pData).u.transition.arr[i10].value.kind == type_1_1_PRESENT) {
                    #if WORD_SIZE==8
                    printf("%s::transition::Elem::value::type_1_1 %lld\n", paramName, (*pData).u.transition.arr[i10].value.u.type_1_1);
                    #else
                    printf("%s::transition::Elem::value::type_1_1 %d\n", paramName, (*pData).u.transition.arr[i10].value.u.type_1_1);
                    #endif
                }
                if ((*pData).u.transition.arr[i10].limit_crossed.kind == type_1_0_PRESENT) {
                    #if WORD_SIZE==8
                    printf("%s::transition::Elem::limit_crossed::type_1_0 %lld\n", paramName, (*pData).u.transition.arr[i10].limit_crossed.u.type_1_0);
                    #else
                    printf("%s::transition::Elem::limit_crossed::type_1_0 %d\n", paramName, (*pData).u.transition.arr[i10].limit_crossed.u.type_1_0);
                    #endif
                }
                else if ((*pData).u.transition.arr[i10].limit_crossed.kind == type_1_1_PRESENT) {
                    #if WORD_SIZE==8
                    printf("%s::transition::Elem::limit_crossed::type_1_1 %lld\n", paramName, (*pData).u.transition.arr[i10].limit_crossed.u.type_1_1);
                    #else
                    printf("%s::transition::Elem::limit_crossed::type_1_1 %d\n", paramName, (*pData).u.transition.arr[i10].limit_crossed.u.type_1_1);
                    #endif
                }
                printf("%s::transition::Elem::previous_checking_status %d\n", paramName, (int)(*pData).u.transition.arr[i10].previous_checking_status);
                printf("%s::transition::Elem::current_checking_status %d\n", paramName, (int)(*pData).u.transition.arr[i10].current_checking_status);
                #if WORD_SIZE==8
                printf("%s::transition::Elem::transition_time::p_field::coarse_time_rep %lld\n", paramName, (*pData).u.transition.arr[i10].transition_time.p_field.coarse_time_rep);
                #else
                printf("%s::transition::Elem::transition_time::p_field::coarse_time_rep %d\n", paramName, (*pData).u.transition.arr[i10].transition_time.p_field.coarse_time_rep);
                #endif
                #if WORD_SIZE==8
                printf("%s::transition::Elem::transition_time::p_field::fine_time_rep %lld\n", paramName, (*pData).u.transition.arr[i10].transition_time.p_field.fine_time_rep);
                #else
                printf("%s::transition::Elem::transition_time::p_field::fine_time_rep %d\n", paramName, (*pData).u.transition.arr[i10].transition_time.p_field.fine_time_rep);
                #endif
                {
                    int i;
                    printf("%s::transition::Elem::transition_time::coarse_time ", paramName);
                    for(i=0; i<4; i++)
                        printf("%c", (*pData).u.transition.arr[i10].transition_time.coarse_time.arr[i]);
                    printf("\n");
                }

                {
                    int i;
                    printf("%s::transition::Elem::transition_time::fine_time ", paramName);
                    for(i=0; i<3; i++)
                        printf("%c", (*pData).u.transition.arr[i10].transition_time.fine_time.arr[i]);
                    printf("\n");
                }

            }
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Octet_String_2(const char *paramName, const asn1SccFixed_Octet_String_2 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<2; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintPus_Relative_Time(const char *paramName, const asn1SccPus_Relative_Time *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    #if WORD_SIZE==8
    printf("%s::p_field::coarse_time_rep %lld\n", paramName, (*pData).p_field.coarse_time_rep);
    #else
    printf("%s::p_field::coarse_time_rep %d\n", paramName, (*pData).p_field.coarse_time_rep);
    #endif
    #if WORD_SIZE==8
    printf("%s::p_field::fine_time_rep %lld\n", paramName, (*pData).p_field.fine_time_rep);
    #else
    printf("%s::p_field::fine_time_rep %d\n", paramName, (*pData).p_field.fine_time_rep);
    #endif
    {
        int i;
        printf("%s::coarse_time ", paramName);
        for(i=0; i<4; i++)
            printf("%c", (*pData).coarse_time.arr[i]);
        printf("\n");
    }

    {
        int i;
        printf("%s::fine_time ", paramName);
        for(i=0; i<3; i++)
            printf("%c", (*pData).fine_time.arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintApplication_Process_ID(const char *paramName, const asn1SccApplication_Process_ID *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    printf("%s %d\n", paramName, (int)(*pData));
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintPus_Time(const char *paramName, const asn1SccPus_Time *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    #if WORD_SIZE==8
    printf("%s::p_field::coarse_time_rep %lld\n", paramName, (*pData).p_field.coarse_time_rep);
    #else
    printf("%s::p_field::coarse_time_rep %d\n", paramName, (*pData).p_field.coarse_time_rep);
    #endif
    #if WORD_SIZE==8
    printf("%s::p_field::fine_time_rep %lld\n", paramName, (*pData).p_field.fine_time_rep);
    #else
    printf("%s::p_field::fine_time_rep %d\n", paramName, (*pData).p_field.fine_time_rep);
    #endif
    {
        int i;
        printf("%s::coarse_time ", paramName);
        for(i=0; i<4; i++)
            printf("%c", (*pData).coarse_time.arr[i]);
        printf("\n");
    }

    {
        int i;
        printf("%s::fine_time ", paramName);
        for(i=0; i<3; i++)
            printf("%c", (*pData).fine_time.arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintUnsigned_Integer(const char *paramName, const asn1SccUnsigned_Integer *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    #if WORD_SIZE==8
    printf("%s %lld\n", paramName, (*pData));
    #else
    printf("%s %d\n", paramName, (*pData));
    #endif
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintCheck_Transition_Report(const char *paramName, const asn1SccCheck_Transition_Report *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i11;
        for(i11=0; i11<(*pData).nCount; i11++) {
            printf("%s::Elem::id %d\n", paramName, (int)(*pData).arr[i11].id);
            if ((*pData).arr[i11].value.kind == type_1_0_PRESENT) {
                #if WORD_SIZE==8
                printf("%s::Elem::value::type_1_0 %lld\n", paramName, (*pData).arr[i11].value.u.type_1_0);
                #else
                printf("%s::Elem::value::type_1_0 %d\n", paramName, (*pData).arr[i11].value.u.type_1_0);
                #endif
            }
            else if ((*pData).arr[i11].value.kind == type_1_1_PRESENT) {
                #if WORD_SIZE==8
                printf("%s::Elem::value::type_1_1 %lld\n", paramName, (*pData).arr[i11].value.u.type_1_1);
                #else
                printf("%s::Elem::value::type_1_1 %d\n", paramName, (*pData).arr[i11].value.u.type_1_1);
                #endif
            }
            if ((*pData).arr[i11].limit_crossed.kind == type_1_0_PRESENT) {
                #if WORD_SIZE==8
                printf("%s::Elem::limit_crossed::type_1_0 %lld\n", paramName, (*pData).arr[i11].limit_crossed.u.type_1_0);
                #else
                printf("%s::Elem::limit_crossed::type_1_0 %d\n", paramName, (*pData).arr[i11].limit_crossed.u.type_1_0);
                #endif
            }
            else if ((*pData).arr[i11].limit_crossed.kind == type_1_1_PRESENT) {
                #if WORD_SIZE==8
                printf("%s::Elem::limit_crossed::type_1_1 %lld\n", paramName, (*pData).arr[i11].limit_crossed.u.type_1_1);
                #else
                printf("%s::Elem::limit_crossed::type_1_1 %d\n", paramName, (*pData).arr[i11].limit_crossed.u.type_1_1);
                #endif
            }
            printf("%s::Elem::previous_checking_status %d\n", paramName, (int)(*pData).arr[i11].previous_checking_status);
            printf("%s::Elem::current_checking_status %d\n", paramName, (int)(*pData).arr[i11].current_checking_status);
            #if WORD_SIZE==8
            printf("%s::Elem::transition_time::p_field::coarse_time_rep %lld\n", paramName, (*pData).arr[i11].transition_time.p_field.coarse_time_rep);
            #else
            printf("%s::Elem::transition_time::p_field::coarse_time_rep %d\n", paramName, (*pData).arr[i11].transition_time.p_field.coarse_time_rep);
            #endif
            #if WORD_SIZE==8
            printf("%s::Elem::transition_time::p_field::fine_time_rep %lld\n", paramName, (*pData).arr[i11].transition_time.p_field.fine_time_rep);
            #else
            printf("%s::Elem::transition_time::p_field::fine_time_rep %d\n", paramName, (*pData).arr[i11].transition_time.p_field.fine_time_rep);
            #endif
            {
                int i;
                printf("%s::Elem::transition_time::coarse_time ", paramName);
                for(i=0; i<4; i++)
                    printf("%c", (*pData).arr[i11].transition_time.coarse_time.arr[i]);
                printf("\n");
            }

            {
                int i;
                printf("%s::Elem::transition_time::fine_time ", paramName);
                for(i=0; i<3; i++)
                    printf("%c", (*pData).arr[i11].transition_time.fine_time.arr[i]);
                printf("\n");
            }

        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintVar_Character_String(const char *paramName, const asn1SccVar_Character_String *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<(*pData).nCount; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintSuccessful_Telecommand_Verification_Report(const char *paramName, const asn1SccSuccessful_Telecommand_Verification_Report *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    #if WORD_SIZE==8
    printf("%s::packet_id %lld\n", paramName, (*pData).packet_id);
    #else
    printf("%s::packet_id %d\n", paramName, (*pData).packet_id);
    #endif
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Bit_String_1(const char *paramName, const asn1SccFixed_Bit_String_1 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i12;
        for(i12=0; i12<1; i12++) {
            printf("%s::Elem %d\n", paramName, (int)(*pData).arr[i12]);
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintParameter_ID_Set(const char *paramName, const asn1SccParameter_ID_Set *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i13;
        for(i13=0; i13<(*pData).nCount; i13++) {
            printf("%s::Elem %d\n", paramName, (int)(*pData).arr[i13]);
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintVerification_Failure_Code(const char *paramName, const asn1SccVerification_Failure_Code *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    #if WORD_SIZE==8
    printf("%s %lld\n", paramName, (*pData));
    #else
    printf("%s %d\n", paramName, (*pData));
    #endif
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintTime_Rep_Spec(const char *paramName, const asn1SccTime_Rep_Spec *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    #if WORD_SIZE==8
    printf("%s::coarse_time_rep %lld\n", paramName, (*pData).coarse_time_rep);
    #else
    printf("%s::coarse_time_rep %d\n", paramName, (*pData).coarse_time_rep);
    #endif
    #if WORD_SIZE==8
    printf("%s::fine_time_rep %lld\n", paramName, (*pData).fine_time_rep);
    #else
    printf("%s::fine_time_rep %d\n", paramName, (*pData).fine_time_rep);
    #endif
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintVar_Octet_String(const char *paramName, const asn1SccVar_Octet_String *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<(*pData).nCount; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintParameter_Value_Set(const char *paramName, const asn1SccParameter_Value_Set *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i14;
        for(i14=0; i14<(*pData).nCount; i14++) {
            if ((*pData).arr[i14].kind == type_1_0_PRESENT) {
                #if WORD_SIZE==8
                printf("%s::Elem::type_1_0 %lld\n", paramName, (*pData).arr[i14].u.type_1_0);
                #else
                printf("%s::Elem::type_1_0 %d\n", paramName, (*pData).arr[i14].u.type_1_0);
                #endif
            }
            else if ((*pData).arr[i14].kind == type_1_1_PRESENT) {
                #if WORD_SIZE==8
                printf("%s::Elem::type_1_1 %lld\n", paramName, (*pData).arr[i14].u.type_1_1);
                #else
                printf("%s::Elem::type_1_1 %d\n", paramName, (*pData).arr[i14].u.type_1_1);
                #endif
            }
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintOn_Board_Fine_Time(const char *paramName, const asn1SccOn_Board_Fine_Time *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<3; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintChecking_Status(const char *paramName, const asn1SccChecking_Status *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    printf("%s %d\n", paramName, (int)(*pData));
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintOn_Board_Coarse_Time(const char *paramName, const asn1SccOn_Board_Coarse_Time *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<4; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintReal_1(const char *paramName, const asn1SccReal_1 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    printf("%s %f\n", paramName, (*pData));
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintParameter_ID(const char *paramName, const asn1SccParameter_ID *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    printf("%s %d\n", paramName, (int)(*pData));
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintReal_2(const char *paramName, const asn1SccReal_2 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    printf("%s %f\n", paramName, (*pData));
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintService_Report(const char *paramName, const asn1SccService_Report *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    if ((*pData).kind == event_reporting_PRESENT) {
        if ((*pData).u.event_reporting.kind == normal_PRESENT) {
            #if WORD_SIZE==8
            printf("%s::event_reporting::normal::rid %lld\n", paramName, (*pData).u.event_reporting.u.normal.rid);
            #else
            printf("%s::event_reporting::normal::rid %d\n", paramName, (*pData).u.event_reporting.u.normal.rid);
            #endif
        }
        else if ((*pData).u.event_reporting.kind == anomaly_PRESENT) {
            if ((*pData).u.event_reporting.u.anomaly.kind == low_PRESENT) {
                #if WORD_SIZE==8
                printf("%s::event_reporting::anomaly::low::rid %lld\n", paramName, (*pData).u.event_reporting.u.anomaly.u.low.rid);
                #else
                printf("%s::event_reporting::anomaly::low::rid %d\n", paramName, (*pData).u.event_reporting.u.anomaly.u.low.rid);
                #endif
            }
            else if ((*pData).u.event_reporting.u.anomaly.kind == medium_PRESENT) {
                #if WORD_SIZE==8
                printf("%s::event_reporting::anomaly::medium::rid %lld\n", paramName, (*pData).u.event_reporting.u.anomaly.u.medium.rid);
                #else
                printf("%s::event_reporting::anomaly::medium::rid %d\n", paramName, (*pData).u.event_reporting.u.anomaly.u.medium.rid);
                #endif
            }
            else if ((*pData).u.event_reporting.u.anomaly.kind == high_PRESENT) {
                #if WORD_SIZE==8
                printf("%s::event_reporting::anomaly::high::rid %lld\n", paramName, (*pData).u.event_reporting.u.anomaly.u.high.rid);
                #else
                printf("%s::event_reporting::anomaly::high::rid %d\n", paramName, (*pData).u.event_reporting.u.anomaly.u.high.rid);
                #endif
            }
        }
    }
    else if ((*pData).kind == telecommand_verification_PRESENT) {
        if ((*pData).u.telecommand_verification.kind == success_PRESENT) {
            #if WORD_SIZE==8
            printf("%s::telecommand_verification::success::packet_id %lld\n", paramName, (*pData).u.telecommand_verification.u.success.packet_id);
            #else
            printf("%s::telecommand_verification::success::packet_id %d\n", paramName, (*pData).u.telecommand_verification.u.success.packet_id);
            #endif
        }
        else if ((*pData).u.telecommand_verification.kind == failure_PRESENT) {
            #if WORD_SIZE==8
            printf("%s::telecommand_verification::failure::packet_id %lld\n", paramName, (*pData).u.telecommand_verification.u.failure.packet_id);
            #else
            printf("%s::telecommand_verification::failure::packet_id %d\n", paramName, (*pData).u.telecommand_verification.u.failure.packet_id);
            #endif
            #if WORD_SIZE==8
            printf("%s::telecommand_verification::failure::code %lld\n", paramName, (*pData).u.telecommand_verification.u.failure.code);
            #else
            printf("%s::telecommand_verification::failure::code %d\n", paramName, (*pData).u.telecommand_verification.u.failure.code);
            #endif
        }
    }
    else if ((*pData).kind == onboard_monitoring_PRESENT) {
        if ((*pData).u.onboard_monitoring.kind == transition_PRESENT) {
            {
                int i15;
                for(i15=0; i15<(*pData).u.onboard_monitoring.u.transition.nCount; i15++) {
                    printf("%s::onboard_monitoring::transition::Elem::id %d\n", paramName, (int)(*pData).u.onboard_monitoring.u.transition.arr[i15].id);
                    if ((*pData).u.onboard_monitoring.u.transition.arr[i15].value.kind == type_1_0_PRESENT) {
                        #if WORD_SIZE==8
                        printf("%s::onboard_monitoring::transition::Elem::value::type_1_0 %lld\n", paramName, (*pData).u.onboard_monitoring.u.transition.arr[i15].value.u.type_1_0);
                        #else
                        printf("%s::onboard_monitoring::transition::Elem::value::type_1_0 %d\n", paramName, (*pData).u.onboard_monitoring.u.transition.arr[i15].value.u.type_1_0);
                        #endif
                    }
                    else if ((*pData).u.onboard_monitoring.u.transition.arr[i15].value.kind == type_1_1_PRESENT) {
                        #if WORD_SIZE==8
                        printf("%s::onboard_monitoring::transition::Elem::value::type_1_1 %lld\n", paramName, (*pData).u.onboard_monitoring.u.transition.arr[i15].value.u.type_1_1);
                        #else
                        printf("%s::onboard_monitoring::transition::Elem::value::type_1_1 %d\n", paramName, (*pData).u.onboard_monitoring.u.transition.arr[i15].value.u.type_1_1);
                        #endif
                    }
                    if ((*pData).u.onboard_monitoring.u.transition.arr[i15].limit_crossed.kind == type_1_0_PRESENT) {
                        #if WORD_SIZE==8
                        printf("%s::onboard_monitoring::transition::Elem::limit_crossed::type_1_0 %lld\n", paramName, (*pData).u.onboard_monitoring.u.transition.arr[i15].limit_crossed.u.type_1_0);
                        #else
                        printf("%s::onboard_monitoring::transition::Elem::limit_crossed::type_1_0 %d\n", paramName, (*pData).u.onboard_monitoring.u.transition.arr[i15].limit_crossed.u.type_1_0);
                        #endif
                    }
                    else if ((*pData).u.onboard_monitoring.u.transition.arr[i15].limit_crossed.kind == type_1_1_PRESENT) {
                        #if WORD_SIZE==8
                        printf("%s::onboard_monitoring::transition::Elem::limit_crossed::type_1_1 %lld\n", paramName, (*pData).u.onboard_monitoring.u.transition.arr[i15].limit_crossed.u.type_1_1);
                        #else
                        printf("%s::onboard_monitoring::transition::Elem::limit_crossed::type_1_1 %d\n", paramName, (*pData).u.onboard_monitoring.u.transition.arr[i15].limit_crossed.u.type_1_1);
                        #endif
                    }
                    printf("%s::onboard_monitoring::transition::Elem::previous_checking_status %d\n", paramName, (int)(*pData).u.onboard_monitoring.u.transition.arr[i15].previous_checking_status);
                    printf("%s::onboard_monitoring::transition::Elem::current_checking_status %d\n", paramName, (int)(*pData).u.onboard_monitoring.u.transition.arr[i15].current_checking_status);
                    #if WORD_SIZE==8
                    printf("%s::onboard_monitoring::transition::Elem::transition_time::p_field::coarse_time_rep %lld\n", paramName, (*pData).u.onboard_monitoring.u.transition.arr[i15].transition_time.p_field.coarse_time_rep);
                    #else
                    printf("%s::onboard_monitoring::transition::Elem::transition_time::p_field::coarse_time_rep %d\n", paramName, (*pData).u.onboard_monitoring.u.transition.arr[i15].transition_time.p_field.coarse_time_rep);
                    #endif
                    #if WORD_SIZE==8
                    printf("%s::onboard_monitoring::transition::Elem::transition_time::p_field::fine_time_rep %lld\n", paramName, (*pData).u.onboard_monitoring.u.transition.arr[i15].transition_time.p_field.fine_time_rep);
                    #else
                    printf("%s::onboard_monitoring::transition::Elem::transition_time::p_field::fine_time_rep %d\n", paramName, (*pData).u.onboard_monitoring.u.transition.arr[i15].transition_time.p_field.fine_time_rep);
                    #endif
                    {
                        int i;
                        printf("%s::onboard_monitoring::transition::Elem::transition_time::coarse_time ", paramName);
                        for(i=0; i<4; i++)
                            printf("%c", (*pData).u.onboard_monitoring.u.transition.arr[i15].transition_time.coarse_time.arr[i]);
                        printf("\n");
                    }

                    {
                        int i;
                        printf("%s::onboard_monitoring::transition::Elem::transition_time::fine_time ", paramName);
                        for(i=0; i<3; i++)
                            printf("%c", (*pData).u.onboard_monitoring.u.transition.arr[i15].transition_time.fine_time.arr[i]);
                        printf("\n");
                    }

                }
            }
        }
    }
    else if ((*pData).kind == event_action_PRESENT) {
        if ((*pData).u.event_action.kind == foo_PRESENT) {
            #if WORD_SIZE==8
            printf("%s::event_action::foo %lld\n", paramName, (*pData).u.event_action.u.foo);
            #else
            printf("%s::event_action::foo %d\n", paramName, (*pData).u.event_action.u.foo);
            #endif
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Bit_String_16(const char *paramName, const asn1SccFixed_Bit_String_16 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i16;
        for(i16=0; i16<16; i16++) {
            printf("%s::Elem %d\n", paramName, (int)(*pData).arr[i16]);
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Bit_String_15(const char *paramName, const asn1SccFixed_Bit_String_15 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i17;
        for(i17=0; i17<15; i17++) {
            printf("%s::Elem %d\n", paramName, (int)(*pData).arr[i17]);
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Bit_String_14(const char *paramName, const asn1SccFixed_Bit_String_14 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i18;
        for(i18=0; i18<14; i18++) {
            printf("%s::Elem %d\n", paramName, (int)(*pData).arr[i18]);
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Bit_String_13(const char *paramName, const asn1SccFixed_Bit_String_13 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i19;
        for(i19=0; i19<13; i19++) {
            printf("%s::Elem %d\n", paramName, (int)(*pData).arr[i19]);
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Bit_String_12(const char *paramName, const asn1SccFixed_Bit_String_12 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i20;
        for(i20=0; i20<12; i20++) {
            printf("%s::Elem %d\n", paramName, (int)(*pData).arr[i20]);
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Bit_String_11(const char *paramName, const asn1SccFixed_Bit_String_11 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i21;
        for(i21=0; i21<11; i21++) {
            printf("%s::Elem %d\n", paramName, (int)(*pData).arr[i21]);
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Bit_String_10(const char *paramName, const asn1SccFixed_Bit_String_10 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i22;
        for(i22=0; i22<10; i22++) {
            printf("%s::Elem %d\n", paramName, (int)(*pData).arr[i22]);
        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintCheck_Transition(const char *paramName, const asn1SccCheck_Transition *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    printf("%s::id %d\n", paramName, (int)(*pData).id);
    if ((*pData).value.kind == type_1_0_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::value::type_1_0 %lld\n", paramName, (*pData).value.u.type_1_0);
        #else
        printf("%s::value::type_1_0 %d\n", paramName, (*pData).value.u.type_1_0);
        #endif
    }
    else if ((*pData).value.kind == type_1_1_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::value::type_1_1 %lld\n", paramName, (*pData).value.u.type_1_1);
        #else
        printf("%s::value::type_1_1 %d\n", paramName, (*pData).value.u.type_1_1);
        #endif
    }
    if ((*pData).limit_crossed.kind == type_1_0_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::limit_crossed::type_1_0 %lld\n", paramName, (*pData).limit_crossed.u.type_1_0);
        #else
        printf("%s::limit_crossed::type_1_0 %d\n", paramName, (*pData).limit_crossed.u.type_1_0);
        #endif
    }
    else if ((*pData).limit_crossed.kind == type_1_1_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::limit_crossed::type_1_1 %lld\n", paramName, (*pData).limit_crossed.u.type_1_1);
        #else
        printf("%s::limit_crossed::type_1_1 %d\n", paramName, (*pData).limit_crossed.u.type_1_1);
        #endif
    }
    printf("%s::previous_checking_status %d\n", paramName, (int)(*pData).previous_checking_status);
    printf("%s::current_checking_status %d\n", paramName, (int)(*pData).current_checking_status);
    #if WORD_SIZE==8
    printf("%s::transition_time::p_field::coarse_time_rep %lld\n", paramName, (*pData).transition_time.p_field.coarse_time_rep);
    #else
    printf("%s::transition_time::p_field::coarse_time_rep %d\n", paramName, (*pData).transition_time.p_field.coarse_time_rep);
    #endif
    #if WORD_SIZE==8
    printf("%s::transition_time::p_field::fine_time_rep %lld\n", paramName, (*pData).transition_time.p_field.fine_time_rep);
    #else
    printf("%s::transition_time::p_field::fine_time_rep %d\n", paramName, (*pData).transition_time.p_field.fine_time_rep);
    #endif
    {
        int i;
        printf("%s::transition_time::coarse_time ", paramName);
        for(i=0; i<4; i++)
            printf("%c", (*pData).transition_time.coarse_time.arr[i]);
        printf("\n");
    }

    {
        int i;
        printf("%s::transition_time::fine_time ", paramName);
        for(i=0; i<3; i++)
            printf("%c", (*pData).transition_time.fine_time.arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintTime_Component_Rep_Spec(const char *paramName, const asn1SccTime_Component_Rep_Spec *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    #if WORD_SIZE==8
    printf("%s %lld\n", paramName, (*pData));
    #else
    printf("%s %d\n", paramName, (*pData));
    #endif
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Octet_String_16(const char *paramName, const asn1SccFixed_Octet_String_16 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<16; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFixed_Character_String_3(const char *paramName, const asn1SccFixed_Character_String_3 *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i;
        printf("%s ", paramName);
        for(i=0; i<3; i++)
            printf("%c", (*pData).arr[i]);
        printf("\n");
    }

#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintNormal_Progress_Report(const char *paramName, const asn1SccNormal_Progress_Report *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    #if WORD_SIZE==8
    printf("%s::rid %lld\n", paramName, (*pData).rid);
    #else
    printf("%s::rid %d\n", paramName, (*pData).rid);
    #endif
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintCheck_Transition_Set(const char *paramName, const asn1SccCheck_Transition_Set *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    {
        int i23;
        for(i23=0; i23<(*pData).nCount; i23++) {
            printf("%s::Elem::id %d\n", paramName, (int)(*pData).arr[i23].id);
            if ((*pData).arr[i23].value.kind == type_1_0_PRESENT) {
                #if WORD_SIZE==8
                printf("%s::Elem::value::type_1_0 %lld\n", paramName, (*pData).arr[i23].value.u.type_1_0);
                #else
                printf("%s::Elem::value::type_1_0 %d\n", paramName, (*pData).arr[i23].value.u.type_1_0);
                #endif
            }
            else if ((*pData).arr[i23].value.kind == type_1_1_PRESENT) {
                #if WORD_SIZE==8
                printf("%s::Elem::value::type_1_1 %lld\n", paramName, (*pData).arr[i23].value.u.type_1_1);
                #else
                printf("%s::Elem::value::type_1_1 %d\n", paramName, (*pData).arr[i23].value.u.type_1_1);
                #endif
            }
            if ((*pData).arr[i23].limit_crossed.kind == type_1_0_PRESENT) {
                #if WORD_SIZE==8
                printf("%s::Elem::limit_crossed::type_1_0 %lld\n", paramName, (*pData).arr[i23].limit_crossed.u.type_1_0);
                #else
                printf("%s::Elem::limit_crossed::type_1_0 %d\n", paramName, (*pData).arr[i23].limit_crossed.u.type_1_0);
                #endif
            }
            else if ((*pData).arr[i23].limit_crossed.kind == type_1_1_PRESENT) {
                #if WORD_SIZE==8
                printf("%s::Elem::limit_crossed::type_1_1 %lld\n", paramName, (*pData).arr[i23].limit_crossed.u.type_1_1);
                #else
                printf("%s::Elem::limit_crossed::type_1_1 %d\n", paramName, (*pData).arr[i23].limit_crossed.u.type_1_1);
                #endif
            }
            printf("%s::Elem::previous_checking_status %d\n", paramName, (int)(*pData).arr[i23].previous_checking_status);
            printf("%s::Elem::current_checking_status %d\n", paramName, (int)(*pData).arr[i23].current_checking_status);
            #if WORD_SIZE==8
            printf("%s::Elem::transition_time::p_field::coarse_time_rep %lld\n", paramName, (*pData).arr[i23].transition_time.p_field.coarse_time_rep);
            #else
            printf("%s::Elem::transition_time::p_field::coarse_time_rep %d\n", paramName, (*pData).arr[i23].transition_time.p_field.coarse_time_rep);
            #endif
            #if WORD_SIZE==8
            printf("%s::Elem::transition_time::p_field::fine_time_rep %lld\n", paramName, (*pData).arr[i23].transition_time.p_field.fine_time_rep);
            #else
            printf("%s::Elem::transition_time::p_field::fine_time_rep %d\n", paramName, (*pData).arr[i23].transition_time.p_field.fine_time_rep);
            #endif
            {
                int i;
                printf("%s::Elem::transition_time::coarse_time ", paramName);
                for(i=0; i<4; i++)
                    printf("%c", (*pData).arr[i23].transition_time.coarse_time.arr[i]);
                printf("\n");
            }

            {
                int i;
                printf("%s::Elem::transition_time::fine_time ", paramName);
                for(i=0; i<3; i++)
                    printf("%c", (*pData).arr[i23].transition_time.fine_time.arr[i]);
                printf("\n");
            }

        }
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintFailing_Telecommand_Verification_Report(const char *paramName, const asn1SccFailing_Telecommand_Verification_Report *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    #if WORD_SIZE==8
    printf("%s::packet_id %lld\n", paramName, (*pData).packet_id);
    #else
    printf("%s::packet_id %d\n", paramName, (*pData).packet_id);
    #endif
    #if WORD_SIZE==8
    printf("%s::code %lld\n", paramName, (*pData).code);
    #else
    printf("%s::code %d\n", paramName, (*pData).code);
    #endif
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

void PrintError_Anomaly_Report(const char *paramName, const asn1SccError_Anomaly_Report *pData)
{
#ifdef __linux__
    pthread_mutex_lock(&g_printing_mutex);
#endif
    if ((*pData).kind == low_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::low::rid %lld\n", paramName, (*pData).u.low.rid);
        #else
        printf("%s::low::rid %d\n", paramName, (*pData).u.low.rid);
        #endif
    }
    else if ((*pData).kind == medium_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::medium::rid %lld\n", paramName, (*pData).u.medium.rid);
        #else
        printf("%s::medium::rid %d\n", paramName, (*pData).u.medium.rid);
        #endif
    }
    else if ((*pData).kind == high_PRESENT) {
        #if WORD_SIZE==8
        printf("%s::high::rid %lld\n", paramName, (*pData).u.high.rid);
        #else
        printf("%s::high::rid %d\n", paramName, (*pData).u.high.rid);
        #endif
    }
#ifdef __linux__
    pthread_mutex_unlock(&g_printing_mutex);
#endif
}

