-- User implementation of the reportedcheckstatetransitions function
-- This file will never be overwritten once edited and modified
-- Only the interface of functions is regenerated (in the .ads file)

pragma style_checks (off);
pragma warnings (off);
with adaasn1rtl;
use adaasn1rtl;

with onboard_parameters;
use onboard_parameters;

with onboard_monitoring_dataview;
use onboard_monitoring_dataview;

package body reportedcheckstatetransitions is

   -- Map from Parameter IDs to their latest reported transition
   type TransitionMap is array (asn1sccParameter_ID) of access asn1sccCheck_Transition;
   theLatestReportedTransitions : TransitionMap := (others => null);

   ---------------------------------------------------------
   -- Provided interface "getLastReportedTransition"
   ---------------------------------------------------------
   procedure getLastReportedTransition (id : access asn1sccParameter_ID; transition : access asn1sccCheck_Transition) is
   begin

      transition.all := theLatestReportedTransitions(id.all).all;

   end getLastReportedTransition;

   ---------------------------------------------------------
   -- Provided interface "updateLastReportedTransition"
   ---------------------------------------------------------
   procedure updateLastReportedTransition (id : access asn1sccParameter_ID; transition : access asn1sccCheck_Transition) is
   begin

      theLatestReportedTransitions(id.all).all := transition.all;

   end updateLastReportedTransition;


end reportedcheckstatetransitions;
