-- User implementation of the missiondatabase function
-- This file will never be overwritten once edited and modified
-- Only the interface of functions is regenerated (in the .ads file)

pragma style_checks (off);
pragma warnings (off);
with adaasn1rtl;
use adaasn1rtl;

with onboard_parameters;
use onboard_parameters;

with onboard_monitoring_dataview;
use onboard_monitoring_dataview;

package body missiondatabase is

   ---------------------------------------------------------
   -- Provided interface "acquireCheckDefinition"
   ---------------------------------------------------------
   procedure acquireCheckDefinition(id: access asn1sccParameter_ID; definition: access asn1sccCheck_Definition) is
   begin

      case id.all is

      when asn1Sccvoltage_1 =>
         declare
            lower : constant asn1SccParameter_Value :=
              asn1SccParameter_Value'(
                                      kind => type_1_0_PRESENT,
                                      type_1_0 => 0);
            upper : constant asn1SccParameter_Value :=
              asn1SccParameter_Value'(
                                      kind => type_1_0_PRESENT,
                                      type_1_0 => 42);
         begin
            definition.lower_bound := lower;
            definition.upper_bound := upper;
         end; -- declare

      when asn1Sccvoltage_2 =>
         declare
            lower : constant asn1SccParameter_Value :=
              asn1SccParameter_Value'(
                                      kind => type_1_1_PRESENT,
                                      type_1_1 => 0);
            upper : constant asn1SccParameter_Value :=
              asn1SccParameter_Value'(
                                      kind => type_1_1_PRESENT,
                                      type_1_1 => 100);
         begin
            definition.lower_bound := lower;
            definition.upper_bound := upper;
         end; -- declare

      end case; -- id

   end acquireCheckDefinition;


end missiondatabase;
