-- User implementation of the checkedparameters function
-- This file will never be overwritten once edited and modified
-- Only the interface of functions is regenerated (in the .ads file)

pragma style_checks (off);
pragma warnings (off);
with adaasn1rtl;
use adaasn1rtl;

with onboard_parameters;
use onboard_parameters;

package body checkedparameters is

   -- Set of identifiers for parameters to be checked
   theCheckedParameters : asn1sccParameter_ID_Set;

	---------------------------------------------------------
	-- Provided interface "getParametersToBeChecked"
	---------------------------------------------------------
	procedure getParametersToBeChecked(theparameters: access asn1sccParameter_ID_Set) is
	begin

		theparameters.all := theCheckedParameters;

	end getParametersToBeChecked;

	---------------------------------------------------------
	-- Provided interface "Configure"
	---------------------------------------------------------
	procedure Configure(parameters: access asn1sccParameter_ID_Set) is
	begin

		theCheckedParameters := parameters.all;

	end Configure;


end checkedparameters;
