#include <stdio.h>
#include <string.h>

#include <assert.h>

#include "C_ASN1_Types.h"

size_t Encode_UPER_Event_Action_Service_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccEvent_Action_Service_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccEvent_Action_Service_Report_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Event-Action-Service-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Event_Action_Service_Report(void *pBuffer, size_t iMaxBufferSize, asn1SccEvent_Action_Service_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccEvent_Action_Service_Report_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Event-Action-Service-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Event_Action_Service_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccEvent_Action_Service_Report *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccEvent_Action_Service_Report) );
    return sizeof(asn1SccEvent_Action_Service_Report);
}

int Decode_UPER_Event_Action_Service_Report(asn1SccEvent_Action_Service_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccEvent_Action_Service_Report_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Event-Action-Service-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Event_Action_Service_Report(asn1SccEvent_Action_Service_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccEvent_Action_Service_Report_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Event-Action-Service-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Event_Action_Service_Report(asn1SccEvent_Action_Service_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccEvent_Action_Service_Report *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Bit_String_7(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_7 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_7_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-7 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Bit_String_7(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Bit_String_7 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_7_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-7 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Bit_String_7(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_7 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Bit_String_7) );
    return sizeof(asn1SccFixed_Bit_String_7);
}

int Decode_UPER_Fixed_Bit_String_7(asn1SccFixed_Bit_String_7 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_7_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-7 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Bit_String_7(asn1SccFixed_Bit_String_7 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_7_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-7 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Bit_String_7(asn1SccFixed_Bit_String_7 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Bit_String_7 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Bit_String_6(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_6 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_6_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-6 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Bit_String_6(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Bit_String_6 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_6_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-6 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Bit_String_6(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_6 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Bit_String_6) );
    return sizeof(asn1SccFixed_Bit_String_6);
}

int Decode_UPER_Fixed_Bit_String_6(asn1SccFixed_Bit_String_6 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_6_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-6 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Bit_String_6(asn1SccFixed_Bit_String_6 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_6_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-6 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Bit_String_6(asn1SccFixed_Bit_String_6 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Bit_String_6 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Signed_Integer(void *pBuffer, size_t iMaxBufferSize, const asn1SccSigned_Integer *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccSigned_Integer_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Signed-Integer (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Signed_Integer(void *pBuffer, size_t iMaxBufferSize, asn1SccSigned_Integer *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccSigned_Integer_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Signed-Integer (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Signed_Integer(void *pBuffer, size_t iMaxBufferSize, const asn1SccSigned_Integer *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccSigned_Integer) );
    return sizeof(asn1SccSigned_Integer);
}

int Decode_UPER_Signed_Integer(asn1SccSigned_Integer *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccSigned_Integer_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Signed-Integer (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Signed_Integer(asn1SccSigned_Integer *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccSigned_Integer_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Signed-Integer (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Signed_Integer(asn1SccSigned_Integer *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccSigned_Integer *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Low_Severity_Error_Anomaly_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccLow_Severity_Error_Anomaly_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccLow_Severity_Error_Anomaly_Report_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Low-Severity-Error-Anomaly-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Low_Severity_Error_Anomaly_Report(void *pBuffer, size_t iMaxBufferSize, asn1SccLow_Severity_Error_Anomaly_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccLow_Severity_Error_Anomaly_Report_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Low-Severity-Error-Anomaly-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Low_Severity_Error_Anomaly_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccLow_Severity_Error_Anomaly_Report *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccLow_Severity_Error_Anomaly_Report) );
    return sizeof(asn1SccLow_Severity_Error_Anomaly_Report);
}

int Decode_UPER_Low_Severity_Error_Anomaly_Report(asn1SccLow_Severity_Error_Anomaly_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccLow_Severity_Error_Anomaly_Report_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Low-Severity-Error-Anomaly-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Low_Severity_Error_Anomaly_Report(asn1SccLow_Severity_Error_Anomaly_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccLow_Severity_Error_Anomaly_Report_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Low-Severity-Error-Anomaly-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Low_Severity_Error_Anomaly_Report(asn1SccLow_Severity_Error_Anomaly_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccLow_Severity_Error_Anomaly_Report *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Telecommand_Verification_Service_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccTelecommand_Verification_Service_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccTelecommand_Verification_Service_Report_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Telecommand-Verification-Service-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Telecommand_Verification_Service_Report(void *pBuffer, size_t iMaxBufferSize, asn1SccTelecommand_Verification_Service_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccTelecommand_Verification_Service_Report_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Telecommand-Verification-Service-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Telecommand_Verification_Service_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccTelecommand_Verification_Service_Report *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccTelecommand_Verification_Service_Report) );
    return sizeof(asn1SccTelecommand_Verification_Service_Report);
}

int Decode_UPER_Telecommand_Verification_Service_Report(asn1SccTelecommand_Verification_Service_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccTelecommand_Verification_Service_Report_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Telecommand-Verification-Service-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Telecommand_Verification_Service_Report(asn1SccTelecommand_Verification_Service_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccTelecommand_Verification_Service_Report_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Telecommand-Verification-Service-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Telecommand_Verification_Service_Report(asn1SccTelecommand_Verification_Service_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccTelecommand_Verification_Service_Report *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Bit_String_4(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_4 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_4_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-4 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Bit_String_4(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Bit_String_4 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_4_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-4 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Bit_String_4(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_4 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Bit_String_4) );
    return sizeof(asn1SccFixed_Bit_String_4);
}

int Decode_UPER_Fixed_Bit_String_4(asn1SccFixed_Bit_String_4 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_4_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-4 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Bit_String_4(asn1SccFixed_Bit_String_4 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_4_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-4 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Bit_String_4(asn1SccFixed_Bit_String_4 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Bit_String_4 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Bit_String_3(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_3 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_3_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-3 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Bit_String_3(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Bit_String_3 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_3_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-3 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Bit_String_3(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_3 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Bit_String_3) );
    return sizeof(asn1SccFixed_Bit_String_3);
}

int Decode_UPER_Fixed_Bit_String_3(asn1SccFixed_Bit_String_3 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_3_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-3 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Bit_String_3(asn1SccFixed_Bit_String_3 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_3_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-3 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Bit_String_3(asn1SccFixed_Bit_String_3 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Bit_String_3 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Character_String_10(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_10 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_10_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-10 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Character_String_10(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Character_String_10 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_10_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-10 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Character_String_10(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_10 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Character_String_10) );
    return sizeof(asn1SccFixed_Character_String_10);
}

int Decode_UPER_Fixed_Character_String_10(asn1SccFixed_Character_String_10 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_10_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-10 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Character_String_10(asn1SccFixed_Character_String_10 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_10_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-10 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Character_String_10(asn1SccFixed_Character_String_10 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Character_String_10 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Octet_String_11(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_11 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_11_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-11 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Octet_String_11(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Octet_String_11 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_11_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-11 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Octet_String_11(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_11 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Octet_String_11) );
    return sizeof(asn1SccFixed_Octet_String_11);
}

int Decode_UPER_Fixed_Octet_String_11(asn1SccFixed_Octet_String_11 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_11_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-11 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Octet_String_11(asn1SccFixed_Octet_String_11 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_11_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-11 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Octet_String_11(asn1SccFixed_Octet_String_11 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Octet_String_11 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Octet_String_10(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_10 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_10_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-10 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Octet_String_10(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Octet_String_10 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_10_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-10 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Octet_String_10(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_10 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Octet_String_10) );
    return sizeof(asn1SccFixed_Octet_String_10);
}

int Decode_UPER_Fixed_Octet_String_10(asn1SccFixed_Octet_String_10 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_10_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-10 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Octet_String_10(asn1SccFixed_Octet_String_10 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_10_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-10 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Octet_String_10(asn1SccFixed_Octet_String_10 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Octet_String_10 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Octet_String_13(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_13 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_13_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-13 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Octet_String_13(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Octet_String_13 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_13_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-13 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Octet_String_13(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_13 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Octet_String_13) );
    return sizeof(asn1SccFixed_Octet_String_13);
}

int Decode_UPER_Fixed_Octet_String_13(asn1SccFixed_Octet_String_13 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_13_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-13 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Octet_String_13(asn1SccFixed_Octet_String_13 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_13_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-13 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Octet_String_13(asn1SccFixed_Octet_String_13 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Octet_String_13 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Octet_String_12(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_12 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_12_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-12 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Octet_String_12(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Octet_String_12 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_12_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-12 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Octet_String_12(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_12 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Octet_String_12) );
    return sizeof(asn1SccFixed_Octet_String_12);
}

int Decode_UPER_Fixed_Octet_String_12(asn1SccFixed_Octet_String_12 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_12_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-12 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Octet_String_12(asn1SccFixed_Octet_String_12 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_12_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-12 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Octet_String_12(asn1SccFixed_Octet_String_12 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Octet_String_12 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Octet_String_15(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_15 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_15_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-15 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Octet_String_15(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Octet_String_15 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_15_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-15 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Octet_String_15(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_15 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Octet_String_15) );
    return sizeof(asn1SccFixed_Octet_String_15);
}

int Decode_UPER_Fixed_Octet_String_15(asn1SccFixed_Octet_String_15 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_15_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-15 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Octet_String_15(asn1SccFixed_Octet_String_15 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_15_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-15 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Octet_String_15(asn1SccFixed_Octet_String_15 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Octet_String_15 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Octet_String_14(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_14 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_14_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-14 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Octet_String_14(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Octet_String_14 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_14_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-14 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Octet_String_14(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_14 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Octet_String_14) );
    return sizeof(asn1SccFixed_Octet_String_14);
}

int Decode_UPER_Fixed_Octet_String_14(asn1SccFixed_Octet_String_14 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_14_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-14 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Octet_String_14(asn1SccFixed_Octet_String_14 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_14_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-14 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Octet_String_14(asn1SccFixed_Octet_String_14 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Octet_String_14 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Octet_String_16(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_16 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_16_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-16 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Octet_String_16(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Octet_String_16 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_16_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-16 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Octet_String_16(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_16 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Octet_String_16) );
    return sizeof(asn1SccFixed_Octet_String_16);
}

int Decode_UPER_Fixed_Octet_String_16(asn1SccFixed_Octet_String_16 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_16_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-16 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Octet_String_16(asn1SccFixed_Octet_String_16 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_16_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-16 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Octet_String_16(asn1SccFixed_Octet_String_16 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Octet_String_16 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Octet_String_9(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_9 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_9_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-9 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Octet_String_9(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Octet_String_9 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_9_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-9 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Octet_String_9(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_9 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Octet_String_9) );
    return sizeof(asn1SccFixed_Octet_String_9);
}

int Decode_UPER_Fixed_Octet_String_9(asn1SccFixed_Octet_String_9 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_9_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-9 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Octet_String_9(asn1SccFixed_Octet_String_9 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_9_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-9 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Octet_String_9(asn1SccFixed_Octet_String_9 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Octet_String_9 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Octet_String_8(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_8 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_8_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-8 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Octet_String_8(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Octet_String_8 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_8_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-8 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Octet_String_8(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_8 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Octet_String_8) );
    return sizeof(asn1SccFixed_Octet_String_8);
}

int Decode_UPER_Fixed_Octet_String_8(asn1SccFixed_Octet_String_8 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_8_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-8 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Octet_String_8(asn1SccFixed_Octet_String_8 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_8_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-8 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Octet_String_8(asn1SccFixed_Octet_String_8 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Octet_String_8 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Octet_String_1(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_1 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_1_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-1 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Octet_String_1(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Octet_String_1 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_1_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-1 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Octet_String_1(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_1 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Octet_String_1) );
    return sizeof(asn1SccFixed_Octet_String_1);
}

int Decode_UPER_Fixed_Octet_String_1(asn1SccFixed_Octet_String_1 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_1_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-1 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Octet_String_1(asn1SccFixed_Octet_String_1 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_1_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-1 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Octet_String_1(asn1SccFixed_Octet_String_1 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Octet_String_1 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Octet_String_3(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_3 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_3_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-3 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Octet_String_3(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Octet_String_3 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_3_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-3 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Octet_String_3(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_3 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Octet_String_3) );
    return sizeof(asn1SccFixed_Octet_String_3);
}

int Decode_UPER_Fixed_Octet_String_3(asn1SccFixed_Octet_String_3 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_3_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-3 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Octet_String_3(asn1SccFixed_Octet_String_3 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_3_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-3 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Octet_String_3(asn1SccFixed_Octet_String_3 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Octet_String_3 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Check_State(void *pBuffer, size_t iMaxBufferSize, const asn1SccCheck_State *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccCheck_State_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Check-State (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Check_State(void *pBuffer, size_t iMaxBufferSize, asn1SccCheck_State *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccCheck_State_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Check-State (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Check_State(void *pBuffer, size_t iMaxBufferSize, const asn1SccCheck_State *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccCheck_State) );
    return sizeof(asn1SccCheck_State);
}

int Decode_UPER_Check_State(asn1SccCheck_State *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccCheck_State_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Check-State (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Check_State(asn1SccCheck_State *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccCheck_State_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Check-State (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Check_State(asn1SccCheck_State *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccCheck_State *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Octet_String_5(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_5 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_5_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-5 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Octet_String_5(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Octet_String_5 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_5_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-5 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Octet_String_5(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_5 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Octet_String_5) );
    return sizeof(asn1SccFixed_Octet_String_5);
}

int Decode_UPER_Fixed_Octet_String_5(asn1SccFixed_Octet_String_5 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_5_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-5 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Octet_String_5(asn1SccFixed_Octet_String_5 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_5_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-5 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Octet_String_5(asn1SccFixed_Octet_String_5 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Octet_String_5 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Octet_String_4(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_4 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_4_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-4 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Octet_String_4(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Octet_String_4 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_4_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-4 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Octet_String_4(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_4 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Octet_String_4) );
    return sizeof(asn1SccFixed_Octet_String_4);
}

int Decode_UPER_Fixed_Octet_String_4(asn1SccFixed_Octet_String_4 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_4_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-4 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Octet_String_4(asn1SccFixed_Octet_String_4 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_4_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-4 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Octet_String_4(asn1SccFixed_Octet_String_4 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Octet_String_4 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Octet_String_7(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_7 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_7_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-7 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Octet_String_7(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Octet_String_7 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_7_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-7 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Octet_String_7(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_7 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Octet_String_7) );
    return sizeof(asn1SccFixed_Octet_String_7);
}

int Decode_UPER_Fixed_Octet_String_7(asn1SccFixed_Octet_String_7 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_7_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-7 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Octet_String_7(asn1SccFixed_Octet_String_7 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_7_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-7 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Octet_String_7(asn1SccFixed_Octet_String_7 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Octet_String_7 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Octet_String_6(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_6 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_6_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-6 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Octet_String_6(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Octet_String_6 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_6_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-6 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Octet_String_6(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_6 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Octet_String_6) );
    return sizeof(asn1SccFixed_Octet_String_6);
}

int Decode_UPER_Fixed_Octet_String_6(asn1SccFixed_Octet_String_6 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_6_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-6 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Octet_String_6(asn1SccFixed_Octet_String_6 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_6_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-6 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Octet_String_6(asn1SccFixed_Octet_String_6 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Octet_String_6 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Transition_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccTransition_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccTransition_Report_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Transition-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Transition_Report(void *pBuffer, size_t iMaxBufferSize, asn1SccTransition_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccTransition_Report_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Transition-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Transition_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccTransition_Report *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccTransition_Report) );
    return sizeof(asn1SccTransition_Report);
}

int Decode_UPER_Transition_Report(asn1SccTransition_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccTransition_Report_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Transition-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Transition_Report(asn1SccTransition_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccTransition_Report_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Transition-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Transition_Report(asn1SccTransition_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccTransition_Report *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Var_Bit_String(void *pBuffer, size_t iMaxBufferSize, const asn1SccVar_Bit_String *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccVar_Bit_String_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Var-Bit-String (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Var_Bit_String(void *pBuffer, size_t iMaxBufferSize, asn1SccVar_Bit_String *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccVar_Bit_String_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Var-Bit-String (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Var_Bit_String(void *pBuffer, size_t iMaxBufferSize, const asn1SccVar_Bit_String *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccVar_Bit_String) );
    return sizeof(asn1SccVar_Bit_String);
}

int Decode_UPER_Var_Bit_String(asn1SccVar_Bit_String *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccVar_Bit_String_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Var-Bit-String (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Var_Bit_String(asn1SccVar_Bit_String *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccVar_Bit_String_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Var-Bit-String (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Var_Bit_String(asn1SccVar_Bit_String *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccVar_Bit_String *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Check_Definition(void *pBuffer, size_t iMaxBufferSize, const asn1SccCheck_Definition *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccCheck_Definition_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Check-Definition (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Check_Definition(void *pBuffer, size_t iMaxBufferSize, asn1SccCheck_Definition *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccCheck_Definition_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Check-Definition (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Check_Definition(void *pBuffer, size_t iMaxBufferSize, const asn1SccCheck_Definition *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccCheck_Definition) );
    return sizeof(asn1SccCheck_Definition);
}

int Decode_UPER_Check_Definition(asn1SccCheck_Definition *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccCheck_Definition_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Check-Definition (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Check_Definition(asn1SccCheck_Definition *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccCheck_Definition_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Check-Definition (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Check_Definition(asn1SccCheck_Definition *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccCheck_Definition *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_High_Severity_Error_Anomaly_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccHigh_Severity_Error_Anomaly_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccHigh_Severity_Error_Anomaly_Report_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode High-Severity-Error-Anomaly-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_High_Severity_Error_Anomaly_Report(void *pBuffer, size_t iMaxBufferSize, asn1SccHigh_Severity_Error_Anomaly_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccHigh_Severity_Error_Anomaly_Report_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode High-Severity-Error-Anomaly-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_High_Severity_Error_Anomaly_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccHigh_Severity_Error_Anomaly_Report *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccHigh_Severity_Error_Anomaly_Report) );
    return sizeof(asn1SccHigh_Severity_Error_Anomaly_Report);
}

int Decode_UPER_High_Severity_Error_Anomaly_Report(asn1SccHigh_Severity_Error_Anomaly_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccHigh_Severity_Error_Anomaly_Report_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode High-Severity-Error-Anomaly-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_High_Severity_Error_Anomaly_Report(asn1SccHigh_Severity_Error_Anomaly_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccHigh_Severity_Error_Anomaly_Report_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode High-Severity-Error-Anomaly-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_High_Severity_Error_Anomaly_Report(asn1SccHigh_Severity_Error_Anomaly_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccHigh_Severity_Error_Anomaly_Report *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Character_String_13(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_13 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_13_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-13 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Character_String_13(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Character_String_13 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_13_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-13 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Character_String_13(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_13 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Character_String_13) );
    return sizeof(asn1SccFixed_Character_String_13);
}

int Decode_UPER_Fixed_Character_String_13(asn1SccFixed_Character_String_13 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_13_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-13 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Character_String_13(asn1SccFixed_Character_String_13 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_13_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-13 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Character_String_13(asn1SccFixed_Character_String_13 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Character_String_13 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Pus_Relative_Time(void *pBuffer, size_t iMaxBufferSize, const asn1SccPus_Relative_Time *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccPus_Relative_Time_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Pus-Relative-Time (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Pus_Relative_Time(void *pBuffer, size_t iMaxBufferSize, asn1SccPus_Relative_Time *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccPus_Relative_Time_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Pus-Relative-Time (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Pus_Relative_Time(void *pBuffer, size_t iMaxBufferSize, const asn1SccPus_Relative_Time *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccPus_Relative_Time) );
    return sizeof(asn1SccPus_Relative_Time);
}

int Decode_UPER_Pus_Relative_Time(asn1SccPus_Relative_Time *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccPus_Relative_Time_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Pus-Relative-Time (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Pus_Relative_Time(asn1SccPus_Relative_Time *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccPus_Relative_Time_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Pus-Relative-Time (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Pus_Relative_Time(asn1SccPus_Relative_Time *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccPus_Relative_Time *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Application_Process_ID(void *pBuffer, size_t iMaxBufferSize, const asn1SccApplication_Process_ID *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccApplication_Process_ID_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Application-Process-ID (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Application_Process_ID(void *pBuffer, size_t iMaxBufferSize, asn1SccApplication_Process_ID *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccApplication_Process_ID_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Application-Process-ID (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Application_Process_ID(void *pBuffer, size_t iMaxBufferSize, const asn1SccApplication_Process_ID *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccApplication_Process_ID) );
    return sizeof(asn1SccApplication_Process_ID);
}

int Decode_UPER_Application_Process_ID(asn1SccApplication_Process_ID *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccApplication_Process_ID_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Application-Process-ID (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Application_Process_ID(asn1SccApplication_Process_ID *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccApplication_Process_ID_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Application-Process-ID (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Application_Process_ID(asn1SccApplication_Process_ID *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccApplication_Process_ID *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Check_Transition_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccCheck_Transition_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccCheck_Transition_Report_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Check-Transition-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Check_Transition_Report(void *pBuffer, size_t iMaxBufferSize, asn1SccCheck_Transition_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccCheck_Transition_Report_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Check-Transition-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Check_Transition_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccCheck_Transition_Report *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccCheck_Transition_Report) );
    return sizeof(asn1SccCheck_Transition_Report);
}

int Decode_UPER_Check_Transition_Report(asn1SccCheck_Transition_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccCheck_Transition_Report_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Check-Transition-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Check_Transition_Report(asn1SccCheck_Transition_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccCheck_Transition_Report_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Check-Transition-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Check_Transition_Report(asn1SccCheck_Transition_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccCheck_Transition_Report *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Parameter_ID_Set(void *pBuffer, size_t iMaxBufferSize, const asn1SccParameter_ID_Set *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccParameter_ID_Set_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Parameter-ID-Set (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Parameter_ID_Set(void *pBuffer, size_t iMaxBufferSize, asn1SccParameter_ID_Set *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccParameter_ID_Set_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Parameter-ID-Set (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Parameter_ID_Set(void *pBuffer, size_t iMaxBufferSize, const asn1SccParameter_ID_Set *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccParameter_ID_Set) );
    return sizeof(asn1SccParameter_ID_Set);
}

int Decode_UPER_Parameter_ID_Set(asn1SccParameter_ID_Set *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccParameter_ID_Set_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Parameter-ID-Set (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Parameter_ID_Set(asn1SccParameter_ID_Set *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccParameter_ID_Set_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Parameter-ID-Set (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Parameter_ID_Set(asn1SccParameter_ID_Set *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccParameter_ID_Set *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Time_Rep_Spec(void *pBuffer, size_t iMaxBufferSize, const asn1SccTime_Rep_Spec *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccTime_Rep_Spec_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Time-Rep-Spec (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Time_Rep_Spec(void *pBuffer, size_t iMaxBufferSize, asn1SccTime_Rep_Spec *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccTime_Rep_Spec_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Time-Rep-Spec (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Time_Rep_Spec(void *pBuffer, size_t iMaxBufferSize, const asn1SccTime_Rep_Spec *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccTime_Rep_Spec) );
    return sizeof(asn1SccTime_Rep_Spec);
}

int Decode_UPER_Time_Rep_Spec(asn1SccTime_Rep_Spec *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccTime_Rep_Spec_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Time-Rep-Spec (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Time_Rep_Spec(asn1SccTime_Rep_Spec *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccTime_Rep_Spec_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Time-Rep-Spec (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Time_Rep_Spec(asn1SccTime_Rep_Spec *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccTime_Rep_Spec *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Bit_String_12(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_12 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_12_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-12 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Bit_String_12(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Bit_String_12 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_12_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-12 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Bit_String_12(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_12 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Bit_String_12) );
    return sizeof(asn1SccFixed_Bit_String_12);
}

int Decode_UPER_Fixed_Bit_String_12(asn1SccFixed_Bit_String_12 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_12_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-12 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Bit_String_12(asn1SccFixed_Bit_String_12 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_12_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-12 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Bit_String_12(asn1SccFixed_Bit_String_12 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Bit_String_12 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Parameter_Value_Set(void *pBuffer, size_t iMaxBufferSize, const asn1SccParameter_Value_Set *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccParameter_Value_Set_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Parameter-Value-Set (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Parameter_Value_Set(void *pBuffer, size_t iMaxBufferSize, asn1SccParameter_Value_Set *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccParameter_Value_Set_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Parameter-Value-Set (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Parameter_Value_Set(void *pBuffer, size_t iMaxBufferSize, const asn1SccParameter_Value_Set *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccParameter_Value_Set) );
    return sizeof(asn1SccParameter_Value_Set);
}

int Decode_UPER_Parameter_Value_Set(asn1SccParameter_Value_Set *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccParameter_Value_Set_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Parameter-Value-Set (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Parameter_Value_Set(asn1SccParameter_Value_Set *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccParameter_Value_Set_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Parameter-Value-Set (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Parameter_Value_Set(asn1SccParameter_Value_Set *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccParameter_Value_Set *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_On_Board_Fine_Time(void *pBuffer, size_t iMaxBufferSize, const asn1SccOn_Board_Fine_Time *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccOn_Board_Fine_Time_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode On-Board-Fine-Time (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_On_Board_Fine_Time(void *pBuffer, size_t iMaxBufferSize, asn1SccOn_Board_Fine_Time *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccOn_Board_Fine_Time_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode On-Board-Fine-Time (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_On_Board_Fine_Time(void *pBuffer, size_t iMaxBufferSize, const asn1SccOn_Board_Fine_Time *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccOn_Board_Fine_Time) );
    return sizeof(asn1SccOn_Board_Fine_Time);
}

int Decode_UPER_On_Board_Fine_Time(asn1SccOn_Board_Fine_Time *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccOn_Board_Fine_Time_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode On-Board-Fine-Time (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_On_Board_Fine_Time(asn1SccOn_Board_Fine_Time *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccOn_Board_Fine_Time_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode On-Board-Fine-Time (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_On_Board_Fine_Time(asn1SccOn_Board_Fine_Time *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccOn_Board_Fine_Time *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Bit_String_16(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_16 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_16_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-16 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Bit_String_16(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Bit_String_16 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_16_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-16 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Bit_String_16(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_16 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Bit_String_16) );
    return sizeof(asn1SccFixed_Bit_String_16);
}

int Decode_UPER_Fixed_Bit_String_16(asn1SccFixed_Bit_String_16 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_16_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-16 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Bit_String_16(asn1SccFixed_Bit_String_16 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_16_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-16 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Bit_String_16(asn1SccFixed_Bit_String_16 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Bit_String_16 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Bit_String_15(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_15 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_15_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-15 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Bit_String_15(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Bit_String_15 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_15_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-15 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Bit_String_15(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_15 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Bit_String_15) );
    return sizeof(asn1SccFixed_Bit_String_15);
}

int Decode_UPER_Fixed_Bit_String_15(asn1SccFixed_Bit_String_15 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_15_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-15 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Bit_String_15(asn1SccFixed_Bit_String_15 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_15_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-15 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Bit_String_15(asn1SccFixed_Bit_String_15 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Bit_String_15 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Bit_String_14(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_14 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_14_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-14 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Bit_String_14(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Bit_String_14 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_14_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-14 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Bit_String_14(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_14 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Bit_String_14) );
    return sizeof(asn1SccFixed_Bit_String_14);
}

int Decode_UPER_Fixed_Bit_String_14(asn1SccFixed_Bit_String_14 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_14_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-14 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Bit_String_14(asn1SccFixed_Bit_String_14 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_14_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-14 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Bit_String_14(asn1SccFixed_Bit_String_14 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Bit_String_14 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Bit_String_13(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_13 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_13_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-13 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Bit_String_13(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Bit_String_13 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_13_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-13 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Bit_String_13(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_13 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Bit_String_13) );
    return sizeof(asn1SccFixed_Bit_String_13);
}

int Decode_UPER_Fixed_Bit_String_13(asn1SccFixed_Bit_String_13 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_13_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-13 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Bit_String_13(asn1SccFixed_Bit_String_13 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_13_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-13 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Bit_String_13(asn1SccFixed_Bit_String_13 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Bit_String_13 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Var_Octet_String(void *pBuffer, size_t iMaxBufferSize, const asn1SccVar_Octet_String *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccVar_Octet_String_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Var-Octet-String (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Var_Octet_String(void *pBuffer, size_t iMaxBufferSize, asn1SccVar_Octet_String *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccVar_Octet_String_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Var-Octet-String (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Var_Octet_String(void *pBuffer, size_t iMaxBufferSize, const asn1SccVar_Octet_String *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccVar_Octet_String) );
    return sizeof(asn1SccVar_Octet_String);
}

int Decode_UPER_Var_Octet_String(asn1SccVar_Octet_String *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccVar_Octet_String_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Var-Octet-String (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Var_Octet_String(asn1SccVar_Octet_String *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccVar_Octet_String_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Var-Octet-String (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Var_Octet_String(asn1SccVar_Octet_String *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccVar_Octet_String *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Bit_String_11(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_11 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_11_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-11 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Bit_String_11(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Bit_String_11 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_11_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-11 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Bit_String_11(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_11 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Bit_String_11) );
    return sizeof(asn1SccFixed_Bit_String_11);
}

int Decode_UPER_Fixed_Bit_String_11(asn1SccFixed_Bit_String_11 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_11_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-11 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Bit_String_11(asn1SccFixed_Bit_String_11 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_11_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-11 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Bit_String_11(asn1SccFixed_Bit_String_11 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Bit_String_11 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Bit_String_10(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_10 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_10_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-10 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Bit_String_10(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Bit_String_10 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_10_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-10 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Bit_String_10(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_10 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Bit_String_10) );
    return sizeof(asn1SccFixed_Bit_String_10);
}

int Decode_UPER_Fixed_Bit_String_10(asn1SccFixed_Bit_String_10 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_10_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-10 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Bit_String_10(asn1SccFixed_Bit_String_10 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_10_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-10 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Bit_String_10(asn1SccFixed_Bit_String_10 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Bit_String_10 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Check_Transition(void *pBuffer, size_t iMaxBufferSize, const asn1SccCheck_Transition *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccCheck_Transition_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Check-Transition (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Check_Transition(void *pBuffer, size_t iMaxBufferSize, asn1SccCheck_Transition *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccCheck_Transition_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Check-Transition (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Check_Transition(void *pBuffer, size_t iMaxBufferSize, const asn1SccCheck_Transition *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccCheck_Transition) );
    return sizeof(asn1SccCheck_Transition);
}

int Decode_UPER_Check_Transition(asn1SccCheck_Transition *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccCheck_Transition_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Check-Transition (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Check_Transition(asn1SccCheck_Transition *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccCheck_Transition_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Check-Transition (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Check_Transition(asn1SccCheck_Transition *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccCheck_Transition *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Error_Anomaly_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccError_Anomaly_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccError_Anomaly_Report_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Error-Anomaly-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Error_Anomaly_Report(void *pBuffer, size_t iMaxBufferSize, asn1SccError_Anomaly_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccError_Anomaly_Report_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Error-Anomaly-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Error_Anomaly_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccError_Anomaly_Report *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccError_Anomaly_Report) );
    return sizeof(asn1SccError_Anomaly_Report);
}

int Decode_UPER_Error_Anomaly_Report(asn1SccError_Anomaly_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccError_Anomaly_Report_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Error-Anomaly-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Error_Anomaly_Report(asn1SccError_Anomaly_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccError_Anomaly_Report_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Error-Anomaly-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Error_Anomaly_Report(asn1SccError_Anomaly_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccError_Anomaly_Report *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Standard_Boolean(void *pBuffer, size_t iMaxBufferSize, const asn1SccStandard_Boolean *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccStandard_Boolean_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Standard-Boolean (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Standard_Boolean(void *pBuffer, size_t iMaxBufferSize, asn1SccStandard_Boolean *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccStandard_Boolean_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Standard-Boolean (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Standard_Boolean(void *pBuffer, size_t iMaxBufferSize, const asn1SccStandard_Boolean *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccStandard_Boolean) );
    return sizeof(asn1SccStandard_Boolean);
}

int Decode_UPER_Standard_Boolean(asn1SccStandard_Boolean *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccStandard_Boolean_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Standard-Boolean (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Standard_Boolean(asn1SccStandard_Boolean *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccStandard_Boolean_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Standard-Boolean (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Standard_Boolean(asn1SccStandard_Boolean *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccStandard_Boolean *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Event_Reporting_Service_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccEvent_Reporting_Service_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccEvent_Reporting_Service_Report_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Event-Reporting-Service-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Event_Reporting_Service_Report(void *pBuffer, size_t iMaxBufferSize, asn1SccEvent_Reporting_Service_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccEvent_Reporting_Service_Report_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Event-Reporting-Service-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Event_Reporting_Service_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccEvent_Reporting_Service_Report *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccEvent_Reporting_Service_Report) );
    return sizeof(asn1SccEvent_Reporting_Service_Report);
}

int Decode_UPER_Event_Reporting_Service_Report(asn1SccEvent_Reporting_Service_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccEvent_Reporting_Service_Report_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Event-Reporting-Service-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Event_Reporting_Service_Report(asn1SccEvent_Reporting_Service_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccEvent_Reporting_Service_Report_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Event-Reporting-Service-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Event_Reporting_Service_Report(asn1SccEvent_Reporting_Service_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccEvent_Reporting_Service_Report *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Report_ID(void *pBuffer, size_t iMaxBufferSize, const asn1SccReport_ID *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccReport_ID_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Report-ID (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Report_ID(void *pBuffer, size_t iMaxBufferSize, asn1SccReport_ID *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccReport_ID_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Report-ID (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Report_ID(void *pBuffer, size_t iMaxBufferSize, const asn1SccReport_ID *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccReport_ID) );
    return sizeof(asn1SccReport_ID);
}

int Decode_UPER_Report_ID(asn1SccReport_ID *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccReport_ID_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Report-ID (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Report_ID(asn1SccReport_ID *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccReport_ID_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Report-ID (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Report_ID(asn1SccReport_ID *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccReport_ID *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_On_Board_Time(void *pBuffer, size_t iMaxBufferSize, const asn1SccOn_Board_Time *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccOn_Board_Time_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode On-Board-Time (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_On_Board_Time(void *pBuffer, size_t iMaxBufferSize, asn1SccOn_Board_Time *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccOn_Board_Time_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode On-Board-Time (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_On_Board_Time(void *pBuffer, size_t iMaxBufferSize, const asn1SccOn_Board_Time *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccOn_Board_Time) );
    return sizeof(asn1SccOn_Board_Time);
}

int Decode_UPER_On_Board_Time(asn1SccOn_Board_Time *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccOn_Board_Time_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode On-Board-Time (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_On_Board_Time(asn1SccOn_Board_Time *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccOn_Board_Time_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode On-Board-Time (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_On_Board_Time(asn1SccOn_Board_Time *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccOn_Board_Time *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Unsigned_Integer(void *pBuffer, size_t iMaxBufferSize, const asn1SccUnsigned_Integer *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccUnsigned_Integer_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Unsigned-Integer (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Unsigned_Integer(void *pBuffer, size_t iMaxBufferSize, asn1SccUnsigned_Integer *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccUnsigned_Integer_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Unsigned-Integer (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Unsigned_Integer(void *pBuffer, size_t iMaxBufferSize, const asn1SccUnsigned_Integer *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccUnsigned_Integer) );
    return sizeof(asn1SccUnsigned_Integer);
}

int Decode_UPER_Unsigned_Integer(asn1SccUnsigned_Integer *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccUnsigned_Integer_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Unsigned-Integer (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Unsigned_Integer(asn1SccUnsigned_Integer *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccUnsigned_Integer_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Unsigned-Integer (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Unsigned_Integer(asn1SccUnsigned_Integer *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccUnsigned_Integer *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Parameter_Value(void *pBuffer, size_t iMaxBufferSize, const asn1SccParameter_Value *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccParameter_Value_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Parameter-Value (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Parameter_Value(void *pBuffer, size_t iMaxBufferSize, asn1SccParameter_Value *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccParameter_Value_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Parameter-Value (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Parameter_Value(void *pBuffer, size_t iMaxBufferSize, const asn1SccParameter_Value *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccParameter_Value) );
    return sizeof(asn1SccParameter_Value);
}

int Decode_UPER_Parameter_Value(asn1SccParameter_Value *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccParameter_Value_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Parameter-Value (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Parameter_Value(asn1SccParameter_Value *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccParameter_Value_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Parameter-Value (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Parameter_Value(asn1SccParameter_Value *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccParameter_Value *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_On_Board_Coarse_Time(void *pBuffer, size_t iMaxBufferSize, const asn1SccOn_Board_Coarse_Time *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccOn_Board_Coarse_Time_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode On-Board-Coarse-Time (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_On_Board_Coarse_Time(void *pBuffer, size_t iMaxBufferSize, asn1SccOn_Board_Coarse_Time *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccOn_Board_Coarse_Time_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode On-Board-Coarse-Time (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_On_Board_Coarse_Time(void *pBuffer, size_t iMaxBufferSize, const asn1SccOn_Board_Coarse_Time *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccOn_Board_Coarse_Time) );
    return sizeof(asn1SccOn_Board_Coarse_Time);
}

int Decode_UPER_On_Board_Coarse_Time(asn1SccOn_Board_Coarse_Time *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccOn_Board_Coarse_Time_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode On-Board-Coarse-Time (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_On_Board_Coarse_Time(asn1SccOn_Board_Coarse_Time *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccOn_Board_Coarse_Time_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode On-Board-Coarse-Time (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_On_Board_Coarse_Time(asn1SccOn_Board_Coarse_Time *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccOn_Board_Coarse_Time *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Telecommand_Packet_ID(void *pBuffer, size_t iMaxBufferSize, const asn1SccTelecommand_Packet_ID *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccTelecommand_Packet_ID_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Telecommand-Packet-ID (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Telecommand_Packet_ID(void *pBuffer, size_t iMaxBufferSize, asn1SccTelecommand_Packet_ID *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccTelecommand_Packet_ID_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Telecommand-Packet-ID (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Telecommand_Packet_ID(void *pBuffer, size_t iMaxBufferSize, const asn1SccTelecommand_Packet_ID *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccTelecommand_Packet_ID) );
    return sizeof(asn1SccTelecommand_Packet_ID);
}

int Decode_UPER_Telecommand_Packet_ID(asn1SccTelecommand_Packet_ID *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccTelecommand_Packet_ID_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Telecommand-Packet-ID (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Telecommand_Packet_ID(asn1SccTelecommand_Packet_ID *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccTelecommand_Packet_ID_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Telecommand-Packet-ID (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Telecommand_Packet_ID(asn1SccTelecommand_Packet_ID *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccTelecommand_Packet_ID *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Bit_String_9(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_9 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_9_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-9 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Bit_String_9(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Bit_String_9 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_9_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-9 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Bit_String_9(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_9 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Bit_String_9) );
    return sizeof(asn1SccFixed_Bit_String_9);
}

int Decode_UPER_Fixed_Bit_String_9(asn1SccFixed_Bit_String_9 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_9_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-9 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Bit_String_9(asn1SccFixed_Bit_String_9 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_9_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-9 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Bit_String_9(asn1SccFixed_Bit_String_9 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Bit_String_9 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Bit_String_8(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_8 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_8_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-8 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Bit_String_8(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Bit_String_8 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_8_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-8 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Bit_String_8(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_8 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Bit_String_8) );
    return sizeof(asn1SccFixed_Bit_String_8);
}

int Decode_UPER_Fixed_Bit_String_8(asn1SccFixed_Bit_String_8 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_8_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-8 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Bit_String_8(asn1SccFixed_Bit_String_8 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_8_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-8 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Bit_String_8(asn1SccFixed_Bit_String_8 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Bit_String_8 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Character_String_15(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_15 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_15_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-15 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Character_String_15(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Character_String_15 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_15_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-15 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Character_String_15(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_15 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Character_String_15) );
    return sizeof(asn1SccFixed_Character_String_15);
}

int Decode_UPER_Fixed_Character_String_15(asn1SccFixed_Character_String_15 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_15_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-15 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Character_String_15(asn1SccFixed_Character_String_15 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_15_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-15 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Character_String_15(asn1SccFixed_Character_String_15 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Character_String_15 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Character_String_14(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_14 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_14_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-14 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Character_String_14(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Character_String_14 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_14_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-14 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Character_String_14(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_14 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Character_String_14) );
    return sizeof(asn1SccFixed_Character_String_14);
}

int Decode_UPER_Fixed_Character_String_14(asn1SccFixed_Character_String_14 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_14_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-14 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Character_String_14(asn1SccFixed_Character_String_14 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_14_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-14 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Character_String_14(asn1SccFixed_Character_String_14 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Character_String_14 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Bit_String_5(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_5 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_5_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-5 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Bit_String_5(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Bit_String_5 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_5_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-5 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Bit_String_5(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_5 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Bit_String_5) );
    return sizeof(asn1SccFixed_Bit_String_5);
}

int Decode_UPER_Fixed_Bit_String_5(asn1SccFixed_Bit_String_5 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_5_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-5 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Bit_String_5(asn1SccFixed_Bit_String_5 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_5_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-5 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Bit_String_5(asn1SccFixed_Bit_String_5 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Bit_String_5 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Character_String_16(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_16 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_16_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-16 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Character_String_16(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Character_String_16 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_16_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-16 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Character_String_16(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_16 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Character_String_16) );
    return sizeof(asn1SccFixed_Character_String_16);
}

int Decode_UPER_Fixed_Character_String_16(asn1SccFixed_Character_String_16 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_16_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-16 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Character_String_16(asn1SccFixed_Character_String_16 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_16_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-16 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Character_String_16(asn1SccFixed_Character_String_16 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Character_String_16 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Character_String_11(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_11 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_11_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-11 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Character_String_11(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Character_String_11 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_11_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-11 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Character_String_11(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_11 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Character_String_11) );
    return sizeof(asn1SccFixed_Character_String_11);
}

int Decode_UPER_Fixed_Character_String_11(asn1SccFixed_Character_String_11 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_11_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-11 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Character_String_11(asn1SccFixed_Character_String_11 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_11_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-11 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Character_String_11(asn1SccFixed_Character_String_11 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Character_String_11 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Bit_String_2(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_2 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_2_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-2 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Bit_String_2(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Bit_String_2 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_2_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-2 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Bit_String_2(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_2 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Bit_String_2) );
    return sizeof(asn1SccFixed_Bit_String_2);
}

int Decode_UPER_Fixed_Bit_String_2(asn1SccFixed_Bit_String_2 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_2_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-2 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Bit_String_2(asn1SccFixed_Bit_String_2 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_2_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-2 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Bit_String_2(asn1SccFixed_Bit_String_2 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Bit_String_2 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Bit_String_1(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_1 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_1_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-1 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Bit_String_1(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Bit_String_1 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Bit_String_1_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Bit-String-1 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Bit_String_1(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Bit_String_1 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Bit_String_1) );
    return sizeof(asn1SccFixed_Bit_String_1);
}

int Decode_UPER_Fixed_Bit_String_1(asn1SccFixed_Bit_String_1 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_1_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-1 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Bit_String_1(asn1SccFixed_Bit_String_1 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Bit_String_1_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Bit-String-1 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Bit_String_1(asn1SccFixed_Bit_String_1 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Bit_String_1 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Character_String_12(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_12 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_12_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-12 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Character_String_12(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Character_String_12 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_12_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-12 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Character_String_12(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_12 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Character_String_12) );
    return sizeof(asn1SccFixed_Character_String_12);
}

int Decode_UPER_Fixed_Character_String_12(asn1SccFixed_Character_String_12 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_12_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-12 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Character_String_12(asn1SccFixed_Character_String_12 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_12_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-12 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Character_String_12(asn1SccFixed_Character_String_12 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Character_String_12 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Character_String_5(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_5 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_5_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-5 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Character_String_5(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Character_String_5 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_5_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-5 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Character_String_5(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_5 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Character_String_5) );
    return sizeof(asn1SccFixed_Character_String_5);
}

int Decode_UPER_Fixed_Character_String_5(asn1SccFixed_Character_String_5 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_5_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-5 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Character_String_5(asn1SccFixed_Character_String_5 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_5_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-5 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Character_String_5(asn1SccFixed_Character_String_5 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Character_String_5 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Character_String_4(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_4 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_4_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-4 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Character_String_4(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Character_String_4 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_4_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-4 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Character_String_4(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_4 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Character_String_4) );
    return sizeof(asn1SccFixed_Character_String_4);
}

int Decode_UPER_Fixed_Character_String_4(asn1SccFixed_Character_String_4 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_4_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-4 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Character_String_4(asn1SccFixed_Character_String_4 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_4_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-4 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Character_String_4(asn1SccFixed_Character_String_4 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Character_String_4 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Character_String_7(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_7 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_7_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-7 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Character_String_7(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Character_String_7 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_7_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-7 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Character_String_7(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_7 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Character_String_7) );
    return sizeof(asn1SccFixed_Character_String_7);
}

int Decode_UPER_Fixed_Character_String_7(asn1SccFixed_Character_String_7 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_7_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-7 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Character_String_7(asn1SccFixed_Character_String_7 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_7_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-7 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Character_String_7(asn1SccFixed_Character_String_7 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Character_String_7 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Character_String_6(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_6 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_6_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-6 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Character_String_6(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Character_String_6 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_6_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-6 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Character_String_6(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_6 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Character_String_6) );
    return sizeof(asn1SccFixed_Character_String_6);
}

int Decode_UPER_Fixed_Character_String_6(asn1SccFixed_Character_String_6 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_6_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-6 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Character_String_6(asn1SccFixed_Character_String_6 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_6_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-6 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Character_String_6(asn1SccFixed_Character_String_6 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Character_String_6 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Character_String_1(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_1 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_1_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-1 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Character_String_1(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Character_String_1 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_1_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-1 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Character_String_1(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_1 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Character_String_1) );
    return sizeof(asn1SccFixed_Character_String_1);
}

int Decode_UPER_Fixed_Character_String_1(asn1SccFixed_Character_String_1 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_1_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-1 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Character_String_1(asn1SccFixed_Character_String_1 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_1_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-1 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Character_String_1(asn1SccFixed_Character_String_1 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Character_String_1 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Character_String_3(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_3 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_3_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-3 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Character_String_3(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Character_String_3 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_3_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-3 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Character_String_3(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_3 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Character_String_3) );
    return sizeof(asn1SccFixed_Character_String_3);
}

int Decode_UPER_Fixed_Character_String_3(asn1SccFixed_Character_String_3 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_3_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-3 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Character_String_3(asn1SccFixed_Character_String_3 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_3_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-3 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Character_String_3(asn1SccFixed_Character_String_3 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Character_String_3 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Character_String_2(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_2 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_2_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-2 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Character_String_2(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Character_String_2 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_2_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-2 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Character_String_2(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_2 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Character_String_2) );
    return sizeof(asn1SccFixed_Character_String_2);
}

int Decode_UPER_Fixed_Character_String_2(asn1SccFixed_Character_String_2 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_2_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-2 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Character_String_2(asn1SccFixed_Character_String_2 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_2_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-2 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Character_String_2(asn1SccFixed_Character_String_2 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Character_String_2 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Character_String_9(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_9 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_9_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-9 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Character_String_9(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Character_String_9 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_9_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-9 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Character_String_9(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_9 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Character_String_9) );
    return sizeof(asn1SccFixed_Character_String_9);
}

int Decode_UPER_Fixed_Character_String_9(asn1SccFixed_Character_String_9 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_9_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-9 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Character_String_9(asn1SccFixed_Character_String_9 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_9_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-9 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Character_String_9(asn1SccFixed_Character_String_9 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Character_String_9 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Character_String_8(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_8 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_8_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-8 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Character_String_8(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Character_String_8 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Character_String_8_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Character-String-8 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Character_String_8(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Character_String_8 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Character_String_8) );
    return sizeof(asn1SccFixed_Character_String_8);
}

int Decode_UPER_Fixed_Character_String_8(asn1SccFixed_Character_String_8 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_8_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-8 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Character_String_8(asn1SccFixed_Character_String_8 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Character_String_8_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Character-String-8 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Character_String_8(asn1SccFixed_Character_String_8 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Character_String_8 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Onboard_Monitoring_Service_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccOnboard_Monitoring_Service_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccOnboard_Monitoring_Service_Report_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Onboard-Monitoring-Service-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Onboard_Monitoring_Service_Report(void *pBuffer, size_t iMaxBufferSize, asn1SccOnboard_Monitoring_Service_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccOnboard_Monitoring_Service_Report_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Onboard-Monitoring-Service-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Onboard_Monitoring_Service_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccOnboard_Monitoring_Service_Report *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccOnboard_Monitoring_Service_Report) );
    return sizeof(asn1SccOnboard_Monitoring_Service_Report);
}

int Decode_UPER_Onboard_Monitoring_Service_Report(asn1SccOnboard_Monitoring_Service_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccOnboard_Monitoring_Service_Report_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Onboard-Monitoring-Service-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Onboard_Monitoring_Service_Report(asn1SccOnboard_Monitoring_Service_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccOnboard_Monitoring_Service_Report_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Onboard-Monitoring-Service-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Onboard_Monitoring_Service_Report(asn1SccOnboard_Monitoring_Service_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccOnboard_Monitoring_Service_Report *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Pus_Time(void *pBuffer, size_t iMaxBufferSize, const asn1SccPus_Time *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccPus_Time_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Pus-Time (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Pus_Time(void *pBuffer, size_t iMaxBufferSize, asn1SccPus_Time *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccPus_Time_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Pus-Time (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Pus_Time(void *pBuffer, size_t iMaxBufferSize, const asn1SccPus_Time *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccPus_Time) );
    return sizeof(asn1SccPus_Time);
}

int Decode_UPER_Pus_Time(asn1SccPus_Time *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccPus_Time_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Pus-Time (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Pus_Time(asn1SccPus_Time *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccPus_Time_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Pus-Time (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Pus_Time(asn1SccPus_Time *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccPus_Time *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Normal_Progress_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccNormal_Progress_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccNormal_Progress_Report_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Normal-Progress-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Normal_Progress_Report(void *pBuffer, size_t iMaxBufferSize, asn1SccNormal_Progress_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccNormal_Progress_Report_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Normal-Progress-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Normal_Progress_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccNormal_Progress_Report *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccNormal_Progress_Report) );
    return sizeof(asn1SccNormal_Progress_Report);
}

int Decode_UPER_Normal_Progress_Report(asn1SccNormal_Progress_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccNormal_Progress_Report_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Normal-Progress-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Normal_Progress_Report(asn1SccNormal_Progress_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccNormal_Progress_Report_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Normal-Progress-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Normal_Progress_Report(asn1SccNormal_Progress_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccNormal_Progress_Report *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Var_Character_String(void *pBuffer, size_t iMaxBufferSize, const asn1SccVar_Character_String *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccVar_Character_String_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Var-Character-String (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Var_Character_String(void *pBuffer, size_t iMaxBufferSize, asn1SccVar_Character_String *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccVar_Character_String_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Var-Character-String (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Var_Character_String(void *pBuffer, size_t iMaxBufferSize, const asn1SccVar_Character_String *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccVar_Character_String) );
    return sizeof(asn1SccVar_Character_String);
}

int Decode_UPER_Var_Character_String(asn1SccVar_Character_String *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccVar_Character_String_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Var-Character-String (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Var_Character_String(asn1SccVar_Character_String *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccVar_Character_String_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Var-Character-String (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Var_Character_String(asn1SccVar_Character_String *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccVar_Character_String *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Successful_Telecommand_Verification_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccSuccessful_Telecommand_Verification_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccSuccessful_Telecommand_Verification_Report_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Successful-Telecommand-Verification-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Successful_Telecommand_Verification_Report(void *pBuffer, size_t iMaxBufferSize, asn1SccSuccessful_Telecommand_Verification_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccSuccessful_Telecommand_Verification_Report_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Successful-Telecommand-Verification-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Successful_Telecommand_Verification_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccSuccessful_Telecommand_Verification_Report *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccSuccessful_Telecommand_Verification_Report) );
    return sizeof(asn1SccSuccessful_Telecommand_Verification_Report);
}

int Decode_UPER_Successful_Telecommand_Verification_Report(asn1SccSuccessful_Telecommand_Verification_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccSuccessful_Telecommand_Verification_Report_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Successful-Telecommand-Verification-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Successful_Telecommand_Verification_Report(asn1SccSuccessful_Telecommand_Verification_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccSuccessful_Telecommand_Verification_Report_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Successful-Telecommand-Verification-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Successful_Telecommand_Verification_Report(asn1SccSuccessful_Telecommand_Verification_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccSuccessful_Telecommand_Verification_Report *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Verification_Failure_Code(void *pBuffer, size_t iMaxBufferSize, const asn1SccVerification_Failure_Code *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccVerification_Failure_Code_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Verification-Failure-Code (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Verification_Failure_Code(void *pBuffer, size_t iMaxBufferSize, asn1SccVerification_Failure_Code *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccVerification_Failure_Code_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Verification-Failure-Code (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Verification_Failure_Code(void *pBuffer, size_t iMaxBufferSize, const asn1SccVerification_Failure_Code *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccVerification_Failure_Code) );
    return sizeof(asn1SccVerification_Failure_Code);
}

int Decode_UPER_Verification_Failure_Code(asn1SccVerification_Failure_Code *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccVerification_Failure_Code_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Verification-Failure-Code (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Verification_Failure_Code(asn1SccVerification_Failure_Code *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccVerification_Failure_Code_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Verification-Failure-Code (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Verification_Failure_Code(asn1SccVerification_Failure_Code *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccVerification_Failure_Code *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Checking_Status(void *pBuffer, size_t iMaxBufferSize, const asn1SccChecking_Status *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccChecking_Status_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Checking-Status (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Checking_Status(void *pBuffer, size_t iMaxBufferSize, asn1SccChecking_Status *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccChecking_Status_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Checking-Status (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Checking_Status(void *pBuffer, size_t iMaxBufferSize, const asn1SccChecking_Status *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccChecking_Status) );
    return sizeof(asn1SccChecking_Status);
}

int Decode_UPER_Checking_Status(asn1SccChecking_Status *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccChecking_Status_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Checking-Status (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Checking_Status(asn1SccChecking_Status *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccChecking_Status_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Checking-Status (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Checking_Status(asn1SccChecking_Status *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccChecking_Status *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Real_1(void *pBuffer, size_t iMaxBufferSize, const asn1SccReal_1 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccReal_1_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Real-1 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Real_1(void *pBuffer, size_t iMaxBufferSize, asn1SccReal_1 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccReal_1_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Real-1 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Real_1(void *pBuffer, size_t iMaxBufferSize, const asn1SccReal_1 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccReal_1) );
    return sizeof(asn1SccReal_1);
}

int Decode_UPER_Real_1(asn1SccReal_1 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccReal_1_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Real-1 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Real_1(asn1SccReal_1 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccReal_1_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Real-1 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Real_1(asn1SccReal_1 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccReal_1 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Parameter_ID(void *pBuffer, size_t iMaxBufferSize, const asn1SccParameter_ID *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccParameter_ID_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Parameter-ID (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Parameter_ID(void *pBuffer, size_t iMaxBufferSize, asn1SccParameter_ID *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccParameter_ID_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Parameter-ID (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Parameter_ID(void *pBuffer, size_t iMaxBufferSize, const asn1SccParameter_ID *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccParameter_ID) );
    return sizeof(asn1SccParameter_ID);
}

int Decode_UPER_Parameter_ID(asn1SccParameter_ID *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccParameter_ID_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Parameter-ID (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Parameter_ID(asn1SccParameter_ID *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccParameter_ID_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Parameter-ID (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Parameter_ID(asn1SccParameter_ID *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccParameter_ID *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Real_2(void *pBuffer, size_t iMaxBufferSize, const asn1SccReal_2 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccReal_2_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Real-2 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Real_2(void *pBuffer, size_t iMaxBufferSize, asn1SccReal_2 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccReal_2_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Real-2 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Real_2(void *pBuffer, size_t iMaxBufferSize, const asn1SccReal_2 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccReal_2) );
    return sizeof(asn1SccReal_2);
}

int Decode_UPER_Real_2(asn1SccReal_2 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccReal_2_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Real-2 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Real_2(asn1SccReal_2 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccReal_2_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Real-2 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Real_2(asn1SccReal_2 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccReal_2 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Service_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccService_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccService_Report_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Service-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Service_Report(void *pBuffer, size_t iMaxBufferSize, asn1SccService_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccService_Report_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Service-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Service_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccService_Report *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccService_Report) );
    return sizeof(asn1SccService_Report);
}

int Decode_UPER_Service_Report(asn1SccService_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccService_Report_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Service-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Service_Report(asn1SccService_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccService_Report_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Service-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Service_Report(asn1SccService_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccService_Report *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Fixed_Octet_String_2(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_2 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_2_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-2 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Fixed_Octet_String_2(void *pBuffer, size_t iMaxBufferSize, asn1SccFixed_Octet_String_2 *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFixed_Octet_String_2_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Fixed-Octet-String-2 (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Fixed_Octet_String_2(void *pBuffer, size_t iMaxBufferSize, const asn1SccFixed_Octet_String_2 *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFixed_Octet_String_2) );
    return sizeof(asn1SccFixed_Octet_String_2);
}

int Decode_UPER_Fixed_Octet_String_2(asn1SccFixed_Octet_String_2 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_2_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-2 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Fixed_Octet_String_2(asn1SccFixed_Octet_String_2 *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFixed_Octet_String_2_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Fixed-Octet-String-2 (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Fixed_Octet_String_2(asn1SccFixed_Octet_String_2 *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFixed_Octet_String_2 *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Time_Component_Rep_Spec(void *pBuffer, size_t iMaxBufferSize, const asn1SccTime_Component_Rep_Spec *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccTime_Component_Rep_Spec_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Time-Component-Rep-Spec (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Time_Component_Rep_Spec(void *pBuffer, size_t iMaxBufferSize, asn1SccTime_Component_Rep_Spec *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccTime_Component_Rep_Spec_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Time-Component-Rep-Spec (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Time_Component_Rep_Spec(void *pBuffer, size_t iMaxBufferSize, const asn1SccTime_Component_Rep_Spec *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccTime_Component_Rep_Spec) );
    return sizeof(asn1SccTime_Component_Rep_Spec);
}

int Decode_UPER_Time_Component_Rep_Spec(asn1SccTime_Component_Rep_Spec *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccTime_Component_Rep_Spec_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Time-Component-Rep-Spec (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Time_Component_Rep_Spec(asn1SccTime_Component_Rep_Spec *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccTime_Component_Rep_Spec_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Time-Component-Rep-Spec (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Time_Component_Rep_Spec(asn1SccTime_Component_Rep_Spec *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccTime_Component_Rep_Spec *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Medium_Severity_Error_Anomaly_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccMedium_Severity_Error_Anomaly_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccMedium_Severity_Error_Anomaly_Report_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Medium-Severity-Error-Anomaly-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Medium_Severity_Error_Anomaly_Report(void *pBuffer, size_t iMaxBufferSize, asn1SccMedium_Severity_Error_Anomaly_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccMedium_Severity_Error_Anomaly_Report_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Medium-Severity-Error-Anomaly-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Medium_Severity_Error_Anomaly_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccMedium_Severity_Error_Anomaly_Report *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccMedium_Severity_Error_Anomaly_Report) );
    return sizeof(asn1SccMedium_Severity_Error_Anomaly_Report);
}

int Decode_UPER_Medium_Severity_Error_Anomaly_Report(asn1SccMedium_Severity_Error_Anomaly_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccMedium_Severity_Error_Anomaly_Report_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Medium-Severity-Error-Anomaly-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Medium_Severity_Error_Anomaly_Report(asn1SccMedium_Severity_Error_Anomaly_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccMedium_Severity_Error_Anomaly_Report_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Medium-Severity-Error-Anomaly-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Medium_Severity_Error_Anomaly_Report(asn1SccMedium_Severity_Error_Anomaly_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccMedium_Severity_Error_Anomaly_Report *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Check_Transition_Set(void *pBuffer, size_t iMaxBufferSize, const asn1SccCheck_Transition_Set *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccCheck_Transition_Set_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Check-Transition-Set (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Check_Transition_Set(void *pBuffer, size_t iMaxBufferSize, asn1SccCheck_Transition_Set *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccCheck_Transition_Set_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Check-Transition-Set (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Check_Transition_Set(void *pBuffer, size_t iMaxBufferSize, const asn1SccCheck_Transition_Set *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccCheck_Transition_Set) );
    return sizeof(asn1SccCheck_Transition_Set);
}

int Decode_UPER_Check_Transition_Set(asn1SccCheck_Transition_Set *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccCheck_Transition_Set_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Check-Transition-Set (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Check_Transition_Set(asn1SccCheck_Transition_Set *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccCheck_Transition_Set_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Check-Transition-Set (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Check_Transition_Set(asn1SccCheck_Transition_Set *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccCheck_Transition_Set *) pBuffer;
    {
        return 0;
    }
}

size_t Encode_UPER_Failing_Telecommand_Verification_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccFailing_Telecommand_Verification_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFailing_Telecommand_Verification_Report_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Failing-Telecommand-Verification-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_ACN_Failing_Telecommand_Verification_Report(void *pBuffer, size_t iMaxBufferSize, asn1SccFailing_Telecommand_Verification_Report *pSrc)
{
    flag errorCode;
    STATIC BitStream strm;

    BitStream_Init(&strm, pBuffer, iMaxBufferSize);
    if (asn1SccFailing_Telecommand_Verification_Report_ACN_Encode(pSrc, &strm, &errorCode, TRUE) == FALSE) {
	fprintf(stderr, "Could not encode Failing-Telecommand-Verification-Report (at %s, %d), errorCode was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    } else {
        return BitStream_GetLength(&strm);
    }
}

size_t Encode_NATIVE_Failing_Telecommand_Verification_Report(void *pBuffer, size_t iMaxBufferSize, const asn1SccFailing_Telecommand_Verification_Report *pSrc)
{
    memcpy(pBuffer, pSrc, sizeof(asn1SccFailing_Telecommand_Verification_Report) );
    return sizeof(asn1SccFailing_Telecommand_Verification_Report);
}

int Decode_UPER_Failing_Telecommand_Verification_Report(asn1SccFailing_Telecommand_Verification_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFailing_Telecommand_Verification_Report_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Failing-Telecommand-Verification-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_ACN_Failing_Telecommand_Verification_Report(asn1SccFailing_Telecommand_Verification_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    flag errorCode;

    STATIC BitStream strm;

    BitStream_AttachBuffer(&strm, pBuffer, iBufferSize);

    if (asn1SccFailing_Telecommand_Verification_Report_ACN_Decode(pDst, &strm, &errorCode)) {
        /* Decoding succeeded */
        return 0;
    } else {
	fprintf(stderr, "Could not decode Failing-Telecommand-Verification-Report (at %s, %d), error code was %d\n", __FILE__, __LINE__, errorCode);
        return -1;
    }
}

int Decode_NATIVE_Failing_Telecommand_Verification_Report(asn1SccFailing_Telecommand_Verification_Report *pDst, void *pBuffer, size_t iBufferSize)
{
    *pDst = *(asn1SccFailing_Telecommand_Verification_Report *) pBuffer;
    {
        return 0;
    }
}

